/*
 *   File:  HushApplet.java
 *
 *   Version 1.04 v1a
 *   Copyright 1998, 1999 by Hush Communications Corporation, BWI
 */

/*============================================================================ 
 Date          Author      Changes

June 21, 1999  Zhou Wu  Multithread connections don't improve sucess rate
                        remove it.

June 15, 1999  Zhou wu  Use mutlithread to make connections: On the server, there
                        may be several ports listening to the clients. So a client
                        now will make the connection with the first sucessful one.

June 2, 1999  Zhou Wu      Change rBody (for reading a message) from a TextArea
                           with both ScrollBars to one with vertical ScrollBar only.
			               This is compatiable with the cBody(for composing a message).

June 1, 1999  Zhou Wu     Remove a few lines in paint method regrading to statusBar.
                          This fixes the repaint problem. "Applet redraw" doesn't need
			              to be shown.

May 27, 1999  Zhou Wu      Add getImageFromJar method which can fetch images
                           from Jar files as resources. Note that Netscape
			   4.51 bug: the Gif89a is not recognized as resources.


May           Zhou Wu      Fix a number of bugs: Buttons overlap, addresses editing(
                           (null point problem), validing hushmail address (the warning
			               message problem), etc.




==============================================================================*/



/*
 *  Applet parameters:
 *
 *  username = < the users HushMail account >
 *  sessionID = < a 64 bit hex number represented as a string >
 *  sessionKey = < a 128 bit hex number represented as a string >
 *  R0 = < red value for applet color >
 *  G0 = < green value for applet color >
 *  B0 = < blue value for applet color >
 *  R1 = < red value for applet color >
 *  G1 = < green value for applet color >
 *  B1 = < blue value for applet color >
 *  clicksPerAdRotation = 
 *     <number of button click between each ad rotation>
 *  keyStrokesPerAdRotation = 
 *     <number of key strokes between each ad rotation>
 *  exitpage = < the url to the script that handles exits >
 *  (optional) smallApplet = < if "yes" applet dimesions are assumed to be 600X350 >
 */

/*  Unless otherwise indicated applet dimensions are assumed to be 720X370 
 */


package hush.gui;

import java.applet.*;
import java.awt.*;
import java.net.*;
import java.util.*;
import java.io.*;

import hush.net.Connection;

public class HushApplet extends Applet
{

  public void init()
  {
      // get parameters.

      getParameters();

    /*  Set the lines per page and maximum string length for 
     *  folder, message, address lists based on applet size
     */

    if (smallApplet)
    {
      linesPerPage = 9;
      maxMessageInfoLength = 165;
      maxFolderInfoLength = 200;
      maxAddressInfoLength = 110;
    }
    else
    {
      linesPerPage = 10;
      maxMessageInfoLength = 165;
      maxFolderInfoLength = 325;
      maxAddressInfoLength = 170;
    }


    /* Format the applet and set it up with a LayoutManager
     */
    setBackground(bgcolor);
    setForeground(Color.white);
    setFont(new Font("Helvetica",Font.PLAIN,12));
    currentScreen = LOGIN_SCREEN;
    appletLayout=new GridBagLayout();
    appletConstraints=new GridBagConstraints();
    setLayout(appletLayout);

    /* Set up the passphrase fields
     */
    passphraseLabel=new Label("Enter passphrase:");
    passphraseLabel.setFont(new Font("Helvetica",Font.PLAIN,12));
    add(this,appletConstraints,passphraseLabel,0,0,1,1,0,0,1,1,NO,NE,20,0,0,0);
    passphraseField=new TextField(50);
    passphraseField.setBackground(Color.white);
    passphraseField.setForeground(Color.black);
    passphraseField.setEchoCharacter('*');
    add(this,appletConstraints,passphraseField,1,0,1,1,0,0,0,1,NO,N,20,0,0,10);
    formatButton3(passphraseButton = new Button("Go"));
    add(this,appletConstraints,passphraseButton,2,0,1,1,0,0,1,1,NO,NW,20,0,0,0);

    /*  Instantiate the class for communication with server.
     *  See "Connection.java" for methods called on this object.
     */
    c = new Connection(getParameter("username"),getParameter("sessionID"),getParameter("sessionKey"),this);

    // get the ports will be used for socket connections;

    getPorts();

    /* After login, the applet has four main panels
     *  1) Menu
     *  2) Commands
     *  3) Main
     *  4) StatusBar
     */

    setUpCommands();
    setUpMain();

    /* set up Status Bar 
     */
    statusBar = new Panel();
    statusBar.setLayout(new GridBagLayout());
    statusBar.setBackground(color);
    statusBar.setForeground(Color.black);
    statusBar.paintAll(statusBar.getGraphics());

  }


  private void getParameters()
	{ /** Simple method for getting the parameters */

	    /* Get applet color and size
	     */
	    color = new Color(Integer.parseInt(getParameter("R1")),
			      Integer.parseInt(getParameter("G1")),
			      Integer.parseInt(getParameter("B1")));
	    bgcolor = new Color(Integer.parseInt(getParameter("R0")),
				Integer.parseInt(getParameter("G0")),
				Integer.parseInt(getParameter("B0")));

	    exitpage = getParameter("exitpage");

	    if (getParameter("small").equals("yes")) smallApplet=true;


            /* Set rotation rate for ads
	     */
	    if (getParameter("keyStrokesPerAdRotation")!=null) 
	    {
		keyStrokesPerAdRotation = 
		    Integer.parseInt(getParameter("keyStrokesPerAdRotation"));
		if (getParameter("clicksPerAdRotation")!=null)
		    clicksPerAdRotation = 
			Integer.parseInt(getParameter("clicksPerAdRotation"));
	    }

	}

    private void getPorts()
	{
	    String ports = getParameter("ports");
            c.setPort((new Integer(ports)).intValue());
 	}

    public void init2()
    {
    /**
    * This method is called after the passphrase has been entered.  It submits
    * the passphrase and username for approval.
    * It completes the setup of the various applet screens and retireves a list
    * of folders, addresses, and the messages in the inbox.  It displays
    * a list of the messages in the inbox.
    */

    /* Add the panels to the applet
     *  The "menu" panel is conceptual only, as it uses the applet itself as a background
     */

    statusBar("Session started");
    add(this,appletConstraints,commands,1,0,1,1,0,10,0,0,B,NW,0,120,0,0);
    add(this,appletConstraints,main,1,1,1,1,0,0,1,1,B,NW,0,120,0,0);
    add(this,appletConstraints,statusBar,1,2,1,1,0,statusBar.bounds().height,0,0,B,NW,0,120,0,0);
    c.setPassphrase(passphraseField.getText());
    passphraseField.setText("");

    try
    {
        if(bDebug)
            System.err.println(" Reach here ");
        if (c.use())
        {
        if (bDebug)
            System.err.print( " Shoudn't be here ");
        listMessages(INBOX,0,true);
        listFolders(0,true);
        listAddresses(0,true);
        if (c.numberOfMessages()>0)
	    add(commands,commandsConstraints,selectAllButton,0,0,1,1,0,0,0,0,NO,W,3,6,3,0);
        else
           add(commands,commandsConstraints,new Label(" "),0,0,1,1,0,0,0,0,NO,W,3,6,3,0);

            commands.invalidate();
            commands.getParent().validate();
        //    if (c.numberOfMessages()==0)
        //    commands.remove(selectAllButton);
        //else
          // add(commands,commandsConstraints,new Label("??"),0,0,1,1,0,0,0,0,NO,W,3,6,3,0);


        c.done();


        remove(passphraseLabel);
        remove(passphraseField);
        remove(passphraseButton);
        /* Show the inbox first
         */
        currentScreen = LIST_MESSAGES_SCREEN;
        mainLayout.show(main,currentScreen);
        loadImages();
        paintAll(getGraphics());
      }
    }
    catch (IOException e)
    {
        if(bDebug)
        {
            e.printStackTrace();
            //c.quit();
        } else
        {
            c.quit();
        }
      String docBase = getDocumentBase().toString();
      try
      {
        URL u = new URL(exitpage+"?action=Error&username="+c.username());
        getAppletContext().showDocument(u);
        c.wipeMessage();
        c.killPassCipher();
        removeAll();
        paintAll(getGraphics());
      }
      catch (MalformedURLException mue) {
      if (bDebug)
        mue.printStackTrace();
        
      System.out.println("Malformed URL");}
      stop();
    }
    if(bDebug)
        System.err.println("Puzzle");
  }

  public void paint(Graphics g)
  {
    /**
     *  Method to override Applet.paint();
     */

      //System.out.println(" repaint or not");   
      /* statusBar.removeAll();
    Label fillerLabel = new Label("Applet redrawn");   
    fillerLabel.setForeground(color);
    statusBar.add(fillerLabel);
    statusBar.paintAll(statusBar.getGraphics());
      */
    paintComponents(g);

    /*  At the start, give focus to the passphrase field
     */
    if (currentScreen.equals(LOGIN_SCREEN)) 
    {
      passphraseField.requestFocus();
    }
    /*  Draw the menu buttons on the applet left side
     */
    else
    { 


/***********************************************************************************
 *  The "menu" panel
 *  This panel is on the far left side of the applet
 *  It consists of five buttons which perform major actions
 *  This panel is never altered after it is set up.  
 *  It isn't actually a seperate panel, but for conceptual purposes
 *  I consider it to be.
 ***********************************************************************************/
       g.drawImage(button0Image,43,20,this);
       g.drawImage(checkImage,13,50,this);
       g.drawImage(button0Image,43,85,this);
       g.drawImage(foldersImage,24,115,this);
       g.drawImage(button0Image,43,150,this);
       g.drawImage(composeImage,23,180,this);
       g.drawImage(button0Image,43,215,this);
       g.drawImage(addressesImage,17,245,this);
       g.drawImage(button0Image,43,280,this);
       g.drawImage(quitImage,38,310,this);
   
       //    }  catch (MalformedURLException e) {System.out.println("MalformedURL");}
    }
  }

  /** load images by Zhou Wu, on May 19,1999 */
  Image button0Image, checkImage, foldersImage, composeImage, addressesImage, quitImage;

  private void loadImages()
	{
	    try
	    {
	    // To: URL u = new URL(getDocumentBase().getProtocol(),getDocumentBase().getHost(),"/images/");

	    URL u= new URL(getDocumentBase().getProtocol(), getDocumentBase().getHost(), "/com/hush/images/");
            if (bDebug)
            {
	        System.out.println(u);
	        System.out.println(" >>>"+getDocumentBase());
            }
	    MediaTracker mt=new MediaTracker(this);
	    String s = "hush/images/";
	     /* button0Image = getImageFromJar(s+"Button0.jpg");
	    checkImage = getImageFromJar(s+"Check.jpg");
	    foldersImage =  getImageFromJar(s+"Folders.jpg");
	    composeImage = getImageFromJar(s+"Compose.jpg");;
	    addressesImage = getImageFromJar(s+"addresses.jpg");;
	    quitImage =  getImageFromJar(s+"Quit.jpg");;
         */
	     button0Image = getImage0(s+"button0.gif");
	    checkImage = getImage0(s+"check.gif");
	    foldersImage =  getImage0(s+"folders.gif");
	    composeImage = getImage0(s+"compose.gif");;
	    addressesImage = getImage0(s+"addresses.gif");;
	    quitImage =  getImage0(s+"quit.gif");;


	    mt.addImage(button0Image,0);
	    mt.addImage(checkImage,1);
	    mt.addImage(foldersImage,2);
	    mt.addImage(composeImage,3);
	    mt.addImage(addressesImage,4);
	    mt.addImage(quitImage,5);
	    mt.waitForAll(0);
	    } catch(Exception e) {
		e.printStackTrace();
		System.err.println("??? error ");
	    }
	}

     private Image getImage0(String fileName)
	{
	    return getImage(getCodeBase(), fileName);
	    }


    /** Method: getImageFromJar()
     *	This method is intended to fetch images from JAR files.
     *  @param fileName a string for the image file's name
     *  @return an image from the JAR file. Or null if not found.
     *  @Waring: the netscape 4.51 doesn't recongize gif89a as a resource.
     *  Don't    use this type of images files.
     */


   /* protected Image getImageFromJar(String fileName)
	{
	    if( fileName == null ) return null;
	    Image image = null;
	    byte[] thanksToNetscape = null;
	    try{
		Toolkit toolkit =
		    Toolkit.getDefaultToolkit();
		InputStream in = this.getClass().getResourceAsStream(fileName);

		if (in == null)
		    System.out.println("No resource found");
		ByteArrayOutputStream baos;
		baos = new ByteArrayOutputStream();
		int c;
		while((c = in.read()) >= 0)
		    baos.write(c);
		image =  getToolkit().createImage(baos.toByteArray());

	    }
	    catch(Exception exc)
	    {
		exc.printStackTrace();
		System.out.println( exc +" getting resource " +fileName );
		return null;
	    }
	    return image;
	}*/




  public void update(Graphics g)
  {
    /**
     *  Method to override Applet.update();
     */

    paint(g);

  } 


 

/***********************************************************************************
 *  Event Handling
 ***********************************************************************************/


 public boolean mouseMove(Event e, int x, int y)
  {   
    if (currentScreen.equals(LOGIN_SCREEN)) return true;
    else if (y>=20 && y<=45 && x>=43 && x<=67)
    {
      getAppletContext().showStatus("Check mail");
    }
    else if (y>=85 && y<=110 && x>=43 && x<=67)
    {
      getAppletContext().showStatus("Folders");
    }
    else if (y>=150 && y<=175 && x>=43 && x<=67)
    {
      getAppletContext().showStatus(COMPOSE_SCREEN);
    }
    else if (y>=215 && y<=240 && x>=43 && x<=67)
    {
      getAppletContext().showStatus(ADDRESSES);
    }
    else if (y>=280 && y<=305 && x>=43 && x<=67) 
    { 
      getAppletContext().showStatus("Quit");
    }
    else getAppletContext().showStatus("");
    return true;
  }  
   
  private boolean bc(int x, int y, Component c)
  {
    int t = c.bounds().y;
    int b = t + c.bounds().height;
    int l = c.bounds().x;
    int r = l + c.bounds().width;
    if (x>l&&x<r&&y>t&&y<b) return true;
    else return false;
  } 


  private boolean lockMenu = false;

  public boolean mouseUp(Event e, int x, int y)
  {
    /**
     *  Overrides Applet.mouseUp
     *  Handle clicks over the graphics on the main menu
     */

    /* Update rotateCount for ad changes
     */
    rotateCount=rotateCount+(keyStrokesPerAdRotation/clicksPerAdRotation); 

    if (currentScreen.equals(LOGIN_SCREEN)) return true;

    /*  Clear status bar
     */
    statusBar.removeAll();

    /* On click of the "Check Mail" button
     */
    if (y>=20 && y<=45 && x>=43 && x<=67 && !lockMenu)
    {
      lockButtons(true);
      if (currentScreen.equals(READ_SCREEN)) c.wipeMessage();
      clearCommands();
      add(commands,commandsConstraints,
        new Label("Retrieving folder info "+
        "                                                                                 "),0,0);
      commands.paintAll(commands.getGraphics());
      try
      {
        c.use();
        // The messages in the inbox are listed
        listMessages(INBOX,0,true);
        // The folder list is updated to reflect changes in the number of
        // messages in the inbox
        listFolders(currentFolderPage,true);
        c.done();
      }  
      catch (IOException e0) {
        error();}
      currentScreen = LIST_MESSAGES_SCREEN;
      mainLayout.show(main,currentScreen);
      clearCommands();
      if (c.numberOfMessages()>0)
      {
        add(commands,commandsConstraints,selectAllButton,0,0);
        showSelectFunctionButtons(messagesSelected()>0,1);  
        commands.paintAll(commands.getGraphics());
      }
      lockButtons(false);
    }

    /* On click of the "Folders" button
     */
    else if (y>=85 && y<=110 && x>=43 && x<=67 && !currentScreen.equals(LIST_FOLDERS) && !lockMenu) 
    {
      if (currentScreen.equals(READ_SCREEN)) c.wipeMessage();
      clearCommands();
      if (bDebug)
      {
       System.out.println(selectAllButton + "????");
       System.out.println(newFolderButton + "....");
       }
      //selectAllButton;
      add(commands,commandsConstraints,newFolderButton,0,0);
      add(commands,commandsConstraints,selectAllButton,1,0);
      currentScreen = LIST_FOLDERS;
      showSelectFunctionButtons(foldersSelected()>0,2);
      mainLayout.show(main,currentScreen);
      commands.paintAll(commands.getGraphics());
    }

    /* On click of the "Compose" button
     */
    else if (y>=150 && y<=175 && x>=43 && x<=67 && !currentScreen.equals(COMPOSE_SCREEN) && !lockMenu)
    { 
      if (currentScreen.equals(READ_SCREEN)) c.wipeMessage();
      clearCommands();
      add(commands,commandsConstraints,backButton,0,0);
      add(commands,commandsConstraints,clearButton,1,0);
      add(commands,commandsConstraints,saveDraftButton,2,0);
      add(commands,commandsConstraints,sendButton,3,0);
      currentScreen = COMPOSE_SCREEN;
      mainLayout.show(main,currentScreen);
      commands.paintAll(commands.getGraphics());
    }
 
    /* On click of the "Addresses" button
     */
    else if (y>=215 && y<=240 && x>=43 && x<=67 && !currentScreen.equals(ADDRESSES) && !lockMenu)
    {
      if (currentScreen.equals(READ_SCREEN)) c.wipeMessage();
      clearCommands();                 
      add(commands,commandsConstraints,newAddressButton,0,0);
      add(commands,commandsConstraints,showFingerprintButton,1,0);
      currentScreen = ADDRESSES;
      mainLayout.show(main,currentScreen);
      commands.paintAll(commands.getGraphics());
    }

    /* On click of the "Quit" button
     */
    else if (y>=280 && y<=305 && x>=43 && x<=67 && !lockMenu) 
    { 
      lockButtons(true);
      clearCommands();
      add(commands,commandsConstraints,
        new Label("Quitting                                                                    "
                 +"                                            " ),0,0);
      commands.paintAll(commands.getGraphics());
      try
      { 
        c.use();
        if(!bDebug)
           c.quit();
      } catch (IOException e1)
      {
        System.out.println("Connection closed");
      }
      try
      {
        URL u = new URL(exitpage+"?action=Quit&username="+c.username());
        getAppletContext().showDocument(u);
        c.wipeMessage();
        c.killPassCipher();
        removeAll();
        paintAll(getGraphics());
      } 
      catch (MalformedURLException mue) {System.out.println("Malformed URL");}
      stop();
    }
    return true;
  }  
 


  public boolean action(Event e, Object o)
  {
    /**
     *  Overrides Applet.action
     *  This method handles actions:  button clicks and text component return presses
     */

    /* Update rotateCount for ad changes
     */
    rotateCount=rotateCount+(keyStrokesPerAdRotation/clicksPerAdRotation);        

    /* The statusBar is cleared with each new action event
     */
    statusBar.removeAll();

    /*  If a passphrase has been entered init2 is called
     */
    if ((e.target==passphraseField || e.target==passphraseButton) && passphraseField.getText().length()>0) init2();

    /* On click of the "Select All" button
     */
    else if (e.target==selectAllButton)
    {
      /*  Action is that all items on the pages are marked as selected.
       *  In the event that all items are already selected, all items
       *  are unselected
       */

      /* If it's a selection of folders
       */
      if (currentScreen.equals(LIST_FOLDERS))
      {
        if (foldersSelected()<numberOfFoldersDisplayed)
          for (int x=currentFolderPage*linesPerPage;x<currentFolderPage*linesPerPage+numberOfFoldersDisplayed;x++) selectFolder(x);
        else for (int x=currentFolderPage*linesPerPage;x<currentFolderPage*linesPerPage+numberOfFoldersDisplayed;x++) unselectFolder(x);
        showSelectFunctionButtons(foldersSelected()>0,2);
      }

      /* If it's a selection of messages
       */
      else if (currentScreen.equals(LIST_MESSAGES_SCREEN))
      {
        if (messagesSelected()<numberOfMessagesDisplayed)
            for (int x=currentMessagePage*linesPerPage;x<currentMessagePage*linesPerPage+numberOfMessagesDisplayed;x++) selectMessage(x);
        else for (int x=currentMessagePage*linesPerPage;x<currentMessagePage*linesPerPage+numberOfMessagesDisplayed;x++) unselectMessage(x);
        showSelectFunctionButtons(messagesSelected()>0,1);
      }
    }


    /* On click of the "Clear" button wipe all fields on compose screen
     */
    else if (e.target==clearButton) 
    { 
      confirmLabel.setText("Are you sure you want to clear this message?");
      clearCommands();
      lockButtons(true);
      add(commands,commandsConstraints,confirmLabel,0,0);
      add(commands,commandsConstraints,confirmDeleteButton,1,0); 
      add(commands,commandsConstraints,cancelDeleteButton,2,0);
      commands.paintAll(commands.getGraphics()); 
    }

    else if (e.target==showFingerprintButton)
    {
      if (smallApplet) statusBar(spaces+"Pub key fingerprint: "+c.fingerprint()+spaces); 
      else statusBar(spaces+"Public key fingerprint: "+c.fingerprint()+spaces); 
    }

    else if (e.target==saveDraftButton)
    {
      /*  Saves a copy of the message currnetly being composed
       *  in the "drafts" folder
       */ 

      String ccs="";   /* A concatenation of headerFields with "Cc:" selected   */ 
      String tos="";   /* A concatenation of headerFields with "To:" selected   */
      String bccs="";  /* A concatenation of headerFields with "Bcc:" selected  */
      String ebcc="";  

      /* Iterate through to/cc/bcc fields to create headerInfo;
       */
      for (int x=0;x<3;x++)
      {
	/* If a headerField contains an address
         */
        if (headerField[x].getText().trim().length()>0)
	{
	  /* If a headerField contains a valid address
           */
          if (validEmailAddresses(headerField[x].getText()))
          {  
	    /* Sort address info into to, cc, or bcc strings
             */
            if (fieldChoice[x].getSelectedItem().equals("To:"))
              tos=tos+headerField[x].getText().trim()+", ";
            else if (fieldChoice[x].getSelectedItem().equals("Cc:")) 
              ccs=ccs+headerField[x].getText().trim()+", ";
            else bccs=bccs+headerField[x].getText().trim()+", ";
          }
          /* Exit if email address is invalid
           */
          else
          {
             headerField[x].requestFocus();
             return false;
          }
	}      
      }

      clearCommands();
      lockButtons(true);
      add(commands,commandsConstraints,
        new Label("Saving draft                                                    "+
                  "                                                                "),0,0);
      commands.paintAll(commands.getGraphics());

      /*  Sort message info into fields understood by
       *  message decryption method in Connection.java
       */
      if (tos.length()>0) tos="E-To: "+tos.substring(0,tos.length()-2)+"\n";
      if (ccs.length()>0) ccs="E-Cc: "+ccs.substring(0,ccs.length()-2)+"\n";
      if (bccs.length()>0) bccs="E-Bcc: "+bccs.substring(0,bccs.length()-2)+"\n";

      /* Since message encryption takes arrays of headers and 
       * recipients, info must be stored in arrays of length 1
       */      

      String[] draftHeader = new String[1];
      String[] draftRecipient = new String[1];

      draftHeader[0]="From "+c.emailAddress()+"  "
        +new Date().toString()+"\n"+cDate.getText().trim()
        +"\nSubject: "+cSubject.getText().trim()+"\nFrom: "
        +c.emailAddress()+"\n"+tos+ccs+bccs;
      draftRecipient[0]=c.username();

      try 
      {
        c.use();
        c.sendEncryptedMessage(draftRecipient,draftHeader,cBody.getText(),true,DRAFTS_BOX);     
        if (c.folderName().equals(DRAFTS_BOX)) listMessages(DRAFTS_BOX,0,true);
        listFolders(currentFolderPage,true);
        c.done();
        clearCommands();
        add(commands,commandsConstraints,selectAllButton,0,0);
        currentScreen = LIST_MESSAGES_SCREEN;
        showSelectFunctionButtons(foldersSelected()>0,1);                
        mainLayout.show(main,currentScreen);
        lockButtons(false);
        cBody.setText("      ");
        compose("","","","","","");
        statusBar(spaces+"Draft saved"+spaces);
      }
      catch (IOException e0) 
      {
        clearCommands();
        lockButtons(false);
        add(commands,commandsConstraints,backButton,0,0);
        add(commands,commandsConstraints,clearButton,1,0);
        add(commands,commandsConstraints,saveDraftButton,2,0);
        add(commands,commandsConstraints,sendButton,3,0);
        currentScreen = COMPOSE_SCREEN;
        mainLayout.show(main,currentScreen);
        error();
      }
    }

    /****
     *  The send routine.  This is long
     **/

    /* On click of the "Send" button send a message
     */
    else if (e.target==sendButton)
    {
      /* Sends the message currently on the compose screen
       */ 

      String headerInfo="";
      String ccs="";   /* A concatenation of headerFields with "Cc:" selected   */ 
      String tos="";   /* A concatenation of headerFields with "To:" selected   */
      String bccs="";  /* A concatenation of headerFields with "Bcc:" selected  */
      String ebcc="";  

      boolean theresAnAddress = false;
     
      if(encryptCheckbox.getState())
      {
	  
	  for (int n=0;n<3;n++)
	      {
		  String t = headerField[n].getText().trim();
		  int l = t.length();
		  if (l>0)
		  {
		      if (!toHushmail(t))
		      {
			  encryptCheckbox.setState(false);
			  //statusBar(spaces+"Can only encrypt to addresses @"+c.domain()+spaces);
			  statusBar(spaces+"Warning: this message cannot be securely sent to these recipients"+spaces);
			  // specialSend = false;
	
			  return true;
			  //break;
		      }
		  }
	      }  
      }  

      /* Iterate through to/cc/bcc fields to create headerInfo;
       */
      for (int x=0;x<3;x++)
      {
	/* If a headerField contains an address
         */
        if (headerField[x].getText().trim().length()>0)
	{
          theresAnAddress = true;
	  /* If a headerField contains a valid address
           */
          if (validEmailAddresses(headerField[x].getText()))
          {
	    /* Sort address into to, cc, or bcc strings
             */
            if (fieldChoice[x].getSelectedItem().equals("To:"))
               tos=tos+headerField[x].getText().trim()+", ";              
            else if (fieldChoice[x].getSelectedItem().equals("Cc:")) 
               ccs=ccs+headerField[x].getText().trim()+", ";
            else bccs=bccs+headerField[x].getText().trim()+", ";
          }
          /* Exit if email address is invalid
           */
	  else
	  {
            headerField[x].requestFocus();
            return false;
          }
	}
      }
      
      if (!theresAnAddress)
      {
        statusBar(spaces+"You must enter an address"+spaces);
        return false;
      }

    /* May 13, 1999 by Zhou Wu */
      //<<
      String sLimit = tos + ccs + bccs;
      StringTokenizer st = new StringTokenizer(sLimit, ",");
      int count =  0;
      int LIMIT = 15;
      while(st.hasMoreTokens())
      {
	  count++;
	  st.nextToken();
      }
      /* Add by Zhou Wu on May 13, 1999 Tempoary solution */
      if ( count > 15 )
      {
	  statusBar("Cannot send to more than " + LIMIT+ " recipients ");
	  return false;
      }
      //>>


      try 
      { 

        boolean wasSent=false;
        clearCommands();
        lockButtons(true);

        /*  If message should be encrypted
         */
        if (encryptCheckbox.getState()) 
        {
 
          add(commands,commandsConstraints,
              new Label("Encrypting and sending message                             "
                       +"                                                           "),0,0);
          commands.paintAll(commands.getGraphics());
	  

	 
	  /*  Save recipient information in "E-" headers so it can be parsed out later.
           *  This is necessary because each recipient must receive a differently
           *  encrypted copy of the message. 
           */
          if (tos.length()>0) tos="E-To: "+tos.substring(0,tos.length()-2)+"\n";
          if (ccs.length()>0) ccs="E-Cc: "+ccs.substring(0,ccs.length()-2)+"\n";
          if (bccs.length()>0) bccs="E-Bcc: "+bccs.substring(0,bccs.length()-2)+"\n";

          /*  Use vectors to store recipient and header info
           *  This is important because each recipient will
           *  receive the same message with different 
           *  header info.  See Connection.sendEncryptedMessage
           */
          Vector recipientsVector=new Vector();
          Vector headersVector=new Vector();
       
          String thisField="";
          String thisAddress="";
          int lastComma;
          boolean inQuotes;

          /*  Parse individual recipients out of header fields
           *  and store appropriate info in vectores
           */
          for (int y=0;y<3;y++)
	  {
            lastComma=-1;
            inQuotes=false;
            thisField = headerField[y].getText();          
            for (int x=0;x<thisField.length();x++)
            {
              if (thisField.regionMatches(x,"\"",0,1)) inQuotes=!inQuotes;
              else if (!inQuotes&&thisField.regionMatches(x,",",0,1)||x==thisField.length()-1)
              {
                if (x==thisField.length()-1) thisAddress=thisField.substring(lastComma+1,x+1).trim();
                else thisAddress=thisField.substring(lastComma+1,x).trim();
                ebcc="";
                if (bccs.length()>0) if (bccs.indexOf(thisAddress)!=-1) ebcc="E-Bcc: "+thisAddress+"\n"; 
                headersVector.addElement(cDate.getText().trim()+"\nSubject: "+cSubject.getText().trim()
                  +"\nFrom: "+c.emailAddress()+"\nTo: "+thisAddress+"\n"+tos+ccs+ebcc);

                if (thisAddress.lastIndexOf('<') > thisAddress.lastIndexOf('"'))
                  thisAddress=thisAddress.substring(thisAddress.lastIndexOf('<')+1,thisAddress.lastIndexOf('>'));
                if (thisAddress.lastIndexOf('@')!=-1) 
                  thisAddress=thisAddress.substring(0,thisAddress.lastIndexOf('@'));

                thisAddress = thisAddress.toLowerCase();
                recipientsVector.addElement(thisAddress);
                lastComma=x;
              }
            }
          }
          if (ccToSelfCheckbox.getState())
	  {
            headersVector.addElement("From "+c.emailAddress()+"  "+new Date().toString()
              +"\n"+cDate.getText().trim()+"\nSubject: "+cSubject.getText().trim()+"\nFrom: "
              +c.emailAddress()+"\nTo: "+c.emailAddress()+"\n"+tos+ccs+ebcc);
	    recipientsVector.addElement("/self/");
          }
          String[] recipientsArray = new String[recipientsVector.size()];
          recipientsVector.copyInto(recipientsArray);
          String[] headersArray = new String[headersVector.size()];
          headersVector.copyInto(headersArray);
          c.use();
          wasSent = c.sendEncryptedMessage(recipientsArray,headersArray,cBody.getText(),false,SENT_BOX);
        }

        /* If message should be sent plain text
         */
        else  
        {

          add(commands,commandsConstraints,
            new Label("Sending unencrypted message                              "),0,0);
          commands.paintAll(commands.getGraphics());
          

          if (tos.length()>0) tos="To: "+tos.substring(0,tos.length()-2)+"\n";
          if (ccs.length()>0) ccs="Cc: "+ccs.substring(0,ccs.length()-2)+"\n";
          if (bccs.length()>0) bccs="Bcc: "+bccs.substring(0,bccs.length()-2)+"\n";
          c.use();
          c.sendPlainMessage(cDate.getText().trim()+"\nSubject: "+cSubject.getText().trim()
            +"\nFrom: "+c.emailAddress()+"\n"+tos+ccs+bccs,cBody.getText(),ccToSelfCheckbox.getState());
          wasSent=true;
        } 
        if (ccToSelfCheckbox.getState() && wasSent)
        {
          if (c.folderName().equals(SENT_BOX)) listMessages(SENT_BOX,0,true);
          listFolders(0,true);
        }
        c.done();

	 if(bDebug)
           debug("Terriblie programs");

        if (wasSent)
        {
          currentScreen = LIST_MESSAGES_SCREEN;
          mainLayout.show(main,currentScreen);
          clearCommands();
	  // fix overlap bug: May 18, 1999 Zhou Wu
          add(commands,commandsConstraints,selectAllButton,0,0);

          showSelectFunctionButtons(messagesSelected()>0,1);
          cBody.setText("                                                             ");
          compose("","","","","","");
          statusBar(spaces+spaces+"Message sent"+spaces+spaces);
          lockButtons(false);
        }                                                         
        else
        {
          clearCommands();
          add(commands,commandsConstraints,backButton,0,0);
          add(commands,commandsConstraints,clearButton,1,0);
          add(commands,commandsConstraints,saveDraftButton,2,0);
          add(commands,commandsConstraints,sendButton,3,0);
          currentScreen = COMPOSE_SCREEN;
          mainLayout.show(main,currentScreen);
          lockButtons(false);
        }
      } 
      catch (IOException e0) 
      {
        clearCommands();
        lockButtons(false);
        add(commands,commandsConstraints,backButton,0,0);
        add(commands,commandsConstraints,clearButton,1,0);
        add(commands,commandsConstraints,saveDraftButton,2,0);
        add(commands,commandsConstraints,sendButton,3,0);
        currentScreen = COMPOSE_SCREEN;
        mainLayout.show(main,currentScreen);
        e0.printStackTrace();
        error();
      }
    }

    /* On click of the "Back" button
     */
    else if (e.target==backButton) 
    {
      //  Return to list of messages in currently open folder
      clearCommands();
      try
      {
        listMessages(c.folderName(),currentMessagePage,false);
      } catch (IOException ee) { /* can't happen */ }
      if (c.numberOfMessages()>0) add(commands,commandsConstraints,selectAllButton,0,0);
      currentScreen = LIST_MESSAGES_SCREEN;
      showSelectFunctionButtons(messagesSelected()>0,1);                    
      mainLayout.show(main,currentScreen);
    }

    /* On click of the "Reply" or "Forward" button
     */
    else if (e.target==replyButton || e.target==forwardButton) 
    {
      clearCommands();
      add(commands,commandsConstraints,backButton,0,0);
      add(commands,commandsConstraints,clearButton,1,0);
      add(commands,commandsConstraints,saveDraftButton,2,0);
      add(commands,commandsConstraints,sendButton,3,0);                    
      StringBuffer mbody = new StringBuffer(c.body());
      if (e.target==replyButton)
      {
        mbody.insert(0,">");
        for (int x=0;x<mbody.length();x++)
          if (mbody.charAt(x)=='\n') mbody.insert(x+1,">");
        String l="At "+c.date()+", "+c.from()+" wrote:\n\n";
        String prefix = "Re: ";
        if (c.subject().regionMatches(true,0,"Re:",0,3)) prefix="";
        if (c.replyTo().length()>0) compose(prefix+
          c.subject().replace('\n',' '),"",
          c.replyTo().replace('\n',' '),"","",l+mbody.toString());
        else compose(prefix+c.subject().replace('\n',' '),"",
           c.from().replace('\n',' '),"","",
           l+mbody.toString());
      }
      else 
      {
        String fm = new String("---------- Forwarded message ----------\n");
        fm=fm+"Date: "+c.date()+"\nSubject: "+c.subject()+"\nFrom: "+c.from()+"\n";
        if (c.replyTo().length()>0) fm=fm+"Reply-to: "+c.replyTo()+"\n";
        fm=fm+"To: "+c.to()+"\n";
        if (c.cc().length()>0) fm=fm+"Cc: "+c.cc()+"\n";
        fm=fm+"\n"+c.body();
        String suffix = "";
        if (c.subject().indexOf("(fwd)")==-1) suffix=" (fwd)";
        compose(c.subject().replace('\n',' ')+suffix,"","","","",fm);
      }
      cDate.setText("Date: "+new Date().toString());
      currentScreen = COMPOSE_SCREEN;
      mainLayout.show(main,currentScreen);
      c.wipeMessage();
    }

    /* On click of the "Delete" button
     */
    else if (e.target==deleteButton || e.target==deleteButtonR)
    {
      if (currentScreen.equals(LIST_FOLDERS) && folderSelected[0]) 
        statusBar(spaces+"Cannot delete inbox"+spaces);
      else
      {
        clearCommands();
        lockButtons(true);
        if (currentScreen.equals(READ_SCREEN)) confirmLabel.setText("Are you sure you want to delete this message?");
        else confirmLabel.setText("Are you sure you want to delete the selection?");
        add(commands,commandsConstraints,confirmLabel,0,0);
        add(commands,commandsConstraints,confirmDeleteButton,1,0); 
        add(commands,commandsConstraints,cancelDeleteButton,2,0);  
        commands.paintAll(commands.getGraphics());
      }
      return true;
    }

    /*  On click of "Ok" button for delete
     */
    else if (e.target==confirmDeleteButton) 
    {
      clearCommands();
      /* Delete a folder
       */
      if (currentScreen.equals(LIST_FOLDERS))
      {
        add(commands,commandsConstraints,
          new Label("Deleting folder(s)                                           "
                   +"                                                             "),0,0);
        commands.paintAll(commands.getGraphics());

	/* Copy folderlist to compensate for changes during multiple deletes
         */
        String[] folderListCopy=new String[c.numberOfFolders()];
        int numberOfFoldersCopy=c.numberOfFolders();
        for (int x=0; x<c.numberOfFolders(); x++)
          folderListCopy[x]=c.folderName(x);

        try 
        { 
          c.use();
          for (int x=0; x<numberOfFoldersCopy; x++)
	  {
            if (folderSelected[x]) c.deleteFolder(folderListCopy[x]);
          }
          listFolders(0,true);
          c.done(); 
        } catch (IOException e1) {error();}

        clearCommands();
        add(commands,commandsConstraints,newFolderButton,0,0);
        add(commands,commandsConstraints,selectAllButton,1,0);
        showSelectFunctionButtons(false,2);
        lockButtons(false);
      }      


      /* Delete a message
       */
      else if (currentScreen.equals(LIST_MESSAGES_SCREEN))
      {  
        add(commands,commandsConstraints,
          new Label("Deleting message(s)                                     "
                   +"                                                        "),0,0);
        commands.paintAll(commands.getGraphics());

	int deleteCount=0;  /* Special variable to compensate for changes during multiple deletes */

        try 
        { 
          c.use();
          for (int x=0; x<c.numberOfMessages(); x++)
            if (messageSelected[x]) 
             {
               c.deleteMessage(c.messageID(x)-deleteCount);
               deleteCount++;
             }
          listMessages(c.folderName(),0,true);
          listFolders(currentFolderPage,true);
          c.done(); 
        } catch (IOException e2) {error();}

        clearCommands();
        if (c.numberOfMessages()>0)
        {
          add(commands,commandsConstraints,selectAllButton,0,0);
          showSelectFunctionButtons(messagesSelected()>0,1);   
        }
        lockButtons(false);
      }

      /* Delete a message off the read screen
       */
      else if (currentScreen.equals(READ_SCREEN))
      {
        add(commands,commandsConstraints,
        new Label("Deleting message                                   "
                 +"                                                   "),0,0);
        commands.paintAll(commands.getGraphics());
        try
        {  
          c.use();
          c.deleteMessage(c.messageID());
          listMessages(c.folderName(),0,true);
          listFolders(currentFolderPage,true);
          c.done();
        } catch (IOException ee) {error();}
        c.wipeMessage();
        clearCommands();
        if (c.numberOfMessages()>0)
        {
          add(commands,commandsConstraints,selectAllButton,0,0);
          showSelectFunctionButtons(messagesSelected()>0,1);
        }
        currentScreen = LIST_MESSAGES_SCREEN;
        lockButtons(false);
        mainLayout.show(main,currentScreen);
      }

      /* Delete an address
       */
      else if (currentScreen.equals(ADDRESSES))
      {
        lockButtons(true);                 
        add(commands,commandsConstraints,
          new Label("Deleting address                                            "+
                    "                                                            "),0,0);
        commands.paintAll(commands.getGraphics());

        try 
        { 
          c.use();
          c.deleteAddress(c.nickname(markForDelete));
          listAddresses(0,true);
          c.done(); 
        }  catch (IOException e3) {error();}
       
        clearCommands();                 
        add(commands,commandsConstraints,newAddressButton,0,0);
        add(commands,commandsConstraints,showFingerprintButton,1,0);
        lockButtons(false);
      }      
      else if (currentScreen.equals(COMPOSE_SCREEN))
      {
        clearCommands();
        add(commands,commandsConstraints,backButton,0,0);
        add(commands,commandsConstraints,clearButton,1,0);
        add(commands,commandsConstraints,saveDraftButton,2,0);
        add(commands,commandsConstraints,sendButton,3,0);
        compose("","","","","","");
        lockButtons(false);
      }
    }

    /* On click of "Cancel" button for delete
     */
    else if (e.target==cancelDeleteButton)
    {
        commands.remove(confirmLabel);
        commands.remove(confirmDeleteButton);
        commands.remove(cancelDeleteButton);
        
        if (currentScreen.equals(LIST_FOLDERS))
	{
          add(commands,commandsConstraints,newFolderButton,0,0);
          add(commands,commandsConstraints,selectAllButton,1,0);
          showSelectFunctionButtons(foldersSelected()>0,2);
        }
        else if (currentScreen.equals(LIST_MESSAGES_SCREEN))
	{ 
          add(commands,commandsConstraints,selectAllButton,0,0);
          showSelectFunctionButtons(messagesSelected()>0,1);
        }
        else if (currentScreen.equals(READ_SCREEN))
	{
          clearCommands(); 
          add(commands,commandsConstraints,backButton,0,0);
          add(commands,commandsConstraints,replyButton,1,0);
          add(commands,commandsConstraints,forwardButton,2,0);
          add(commands,commandsConstraints,deleteButtonR,3,0);
          add(commands,commandsConstraints,saveButtonR,4,0);
        }
        else if (currentScreen.equals(COMPOSE_SCREEN))
        {
          clearCommands();
          add(commands,commandsConstraints,backButton,0,0);
          add(commands,commandsConstraints,clearButton,1,0);
          add(commands,commandsConstraints,saveDraftButton,2,0);
          add(commands,commandsConstraints,sendButton,3,0);
        }
        lockButtons(false);
    }

    /* On click of the "New Folder" button
     */
    else if (e.target==newFolderButton) 
    {
      clearCommands();
      lockButtons(true);
      if (smallApplet)
        formatTextComponent(newFolderField = new TextField(18),true);
      else formatTextComponent(newFolderField = new TextField(26),true);
      add(commands,commandsConstraints,newNameLabel,0,0);
      add(commands,commandsConstraints,newFolderField,1,0);
      add(commands,commandsConstraints,smallNewFolderButton,2,0);
      add(commands,commandsConstraints,cancelNewFolderButton,3,0);  
      commands.paintAll(commands.getGraphics());
      newFolderField.requestFocus(); 
      return true;
    }

    /* On enter of new name for folder
     */
    else if (e.target==newFolderField || e.target==smallNewFolderButton)
    {
      String newFolderName=newFolderField.getText().trim();
      if (validFolderName(newFolderName))
      {
        for (int a=0;a<c.numberOfFolders();a++)
        {
          if (c.folderName(a).equals(newFolderName)) 
	  {
            statusBar(spaces+"That foldername already exists!"+spaces);
            ignoreLostFocus = true;
            newFolderField.requestFocus();
            return true;
          }
        }

        clearCommands();
        add(commands,commandsConstraints,
          new Label("Creating folder                                       "    
                    +"                                                     "),0,0);
        commands.paintAll(commands.getGraphics());
        int x;
        for (x=0;x<c.numberOfFolders();x++)
        if (folderSelected[x]) break;
        try
        { 
          c.use();
          c.newFolder(newFolderName);
          listFolders(currentFolderPage,true);
          c.done();
        } catch (IOException e4) {error();}
        clearCommands();
        add(commands,commandsConstraints,newFolderButton,0,0);
        add(commands,commandsConstraints,selectAllButton,1,0);
        showSelectFunctionButtons(foldersSelected()>0,2);  
        lockButtons(false);
      }
      else
      {
        ignoreLostFocus=true; 
        newFolderField.requestFocus();
      }
    }  
  
    /* On click of "Cancel" button for new folder
     */
    else if (e.target==cancelNewFolderButton)
    {
      commands.remove(newNameLabel);
      commands.remove(newFolderField);
      commands.remove(smallNewFolderButton);
      commands.remove(cancelNewFolderButton);
      add(commands,commandsConstraints,newFolderButton,0,0);
      add(commands,commandsConstraints,selectAllButton,1,0);
      showSelectFunctionButtons(foldersSelected()>0,2);
      lockButtons(false);
    }

    /* On click of the "Save" button
     */
    else if (e.target==saveButton || e.target==saveButtonR)
    {
      lockButtons(true);
      clearCommands();
      folderChoice = new Choice();
      folderChoice.setBackground(Color.white);
      folderChoice.setFont(new Font("Helvetica",Font.PLAIN,12));
      for (int x=0;x<c.numberOfFolders();x++)
        if (!c.folderName(x).equals(c.folderName()))
          folderChoice.addItem(c.folderName(x));
      add(commands,commandsConstraints,saveMessageLabel,0,0);
      add(commands,commandsConstraints,folderChoice,1,0);
      add(commands,commandsConstraints,smallSaveButton,2,0);
      add(commands,commandsConstraints,cancelSaveButton,3,0);
    }

    /* On selection of folder to save message to
     */
    else if (e.target==smallSaveButton)
    {
      clearCommands();
      add(commands,commandsConstraints,
        new Label("Moving message(s)                                 "
                 +"                                                  "),0,0);
      commands.paintAll(commands.getGraphics());    
      if (currentScreen.equals(READ_SCREEN))
      {
        try 
        { 
          c.use();
          c.moveMessage(c.messageID(),folderChoice.getSelectedItem());
          listMessages(c.folderName(),0,true);
          listFolders(currentFolderPage,true);
          c.done();
        } catch (IOException e5) {error();}
        c.wipeMessage();
        clearCommands();
        if (c.numberOfMessages()>0)
        {
          add(commands,commandsConstraints,selectAllButton,0,0);
          showSelectFunctionButtons(messagesSelected()>0,1);   
        }
        currentScreen = LIST_MESSAGES_SCREEN;
        lockButtons(false);
        mainLayout.show(main,currentScreen);
      }
      else
      {
        int saveCount=0;  // Special variable to compensate for changes during multiple saves
        try { c.use();
        for (int x=0; x<c.numberOfMessages(); x++)
          if (messageSelected[x])
	  {
            c.moveMessage(c.messageID(x)-saveCount,folderChoice.getSelectedItem());
            saveCount++;
          }
        listMessages(c.folderName(),0,true);
        listFolders(currentFolderPage,true);
        c.done(); } catch (IOException e5) {error();}

        clearCommands();
        if (c.numberOfMessages()>0)
        {
          add(commands,commandsConstraints,selectAllButton,0,0);
          showSelectFunctionButtons(messagesSelected()>0,1);   
        }
      }       
      lockButtons(false);
    }

    /* On click of cancel button for save
     */
    else if (e.target==cancelSaveButton)
    {
      clearCommands(); 
      if (currentScreen.equals(READ_SCREEN))
      {
        add(commands,commandsConstraints,backButton,0,0);
        add(commands,commandsConstraints,replyButton,1,0);
        add(commands,commandsConstraints,forwardButton,2,0);
        add(commands,commandsConstraints,deleteButtonR,3,0);
        add(commands,commandsConstraints,saveButtonR,4,0);
      }
      else
      {
        add(commands,commandsConstraints,selectAllButton,0,0);
        showSelectFunctionButtons(messagesSelected()>0,1);
      }   
      lockButtons(false);
    }
 
    /* On click of "Rename Selected" button
     */
    else if (e.target==renameButton)
    {
      if (folderSelected[0]) statusBar(spaces+"Cannot rename inbox"+spaces);
      else
      {
        lockButtons(true);
        clearCommands();
        formatTextComponent(renameFolderField = new TextField(12),true);
        add(commands,commandsConstraints,newNameLabel,0,0);
        add(commands,commandsConstraints,renameFolderField,1,0);
        add(commands,commandsConstraints,smallRenameButton,2,0); 
        add(commands,commandsConstraints,cancelRenameButton,3,0);
        commands.paintAll(commands.getGraphics()); 
        renameFolderField.requestFocus(); 
      }
      return true;
    }

    /* On enter of new name for folder
     */
    else if (e.target==renameFolderField || e.target==smallRenameButton)
    {
      String newFolderName=renameFolderField.getText().trim();
      if (validFolderName(newFolderName))
      {
        for (int a=0;a<c.numberOfFolders();a++)
        {
          if (c.folderName(a).equals(newFolderName) && !folderSelected[a]) 
	  {
            statusBar(spaces+"That foldername already exists!"+spaces);
            ignoreLostFocus = true;
            renameFolderField.requestFocus();
            return true;
          }
        }
        
        clearCommands();
        add(commands,commandsConstraints,
          new Label("Renaming folder                                           "
                   +"                                                          "),0,0);
        commands.paintAll(commands.getGraphics());
        int x;
        for (x=0;x<c.numberOfFolders();x++) if (folderSelected[x]) break;
        try 
        { 
          c.use();
          c.renameFolder(c.folderName(x),newFolderName);
          listFolders(currentFolderPage,true);
          c.done(); 
        } catch (IOException e6) {error();}
        showSelectFunctionButtons(false,0);  
        clearCommands();
        add(commands,commandsConstraints,newFolderButton,0,0);
        add(commands,commandsConstraints,selectAllButton,1,0);
        showSelectFunctionButtons(foldersSelected()>2,0);  
        lockButtons(false);
      }
      else 
      {
        ignoreLostFocus=true;
        renameFolderField.requestFocus();
      }
    }
    
    /* On click of "Cancel" button for renaming a folder
     */
    else if (e.target==cancelRenameButton)
    {
      commands.remove(newNameLabel);
      commands.remove(renameFolderField);
      commands.remove(smallRenameButton);
      commands.remove(cancelRenameButton);
      add(commands,commandsConstraints,newFolderButton,0,0);
      add(commands,commandsConstraints,selectAllButton,1,0);
      showSelectFunctionButtons(foldersSelected()>2,0);  
      lockButtons(false);
    }

    /* On click of the "New Address" button
     */
    else if (e.target==newAddressButton)
    {
      lockButtons(true);
      addressesPanel.removeAll();
      add(addressesPanel,aConstraints,new Label("Enter new address information here..."),
         0,0,2,1,0,0,1,0,NO,NW,0,6,0,6);
      add(addressesPanel,aConstraints,colorLabel(new Label("Nickname:")),0,1,1,1,0,0,0,0,NO,NW,0,6,0,6);
      add(addressesPanel,aConstraints,colorLabel(new Label("Full Name:")),0,2);
      add(addressesPanel,aConstraints,colorLabel(new Label("Email Address:")),0,3);
      add(addressesPanel,aConstraints,newNicknameField=new TextField(10),1,1,1,1,0,0,1,0,B,NW,0,6,0,6);
      add(addressesPanel,aConstraints,newFullnameField=new TextField(10),1,2);
      add(addressesPanel,aConstraints,newAddressField=new TextField(10),1,3);
      add(addressesPanel,aConstraints,saveAddressButton=new Button("Done"),0,4,1,1,0,0,0,1,NO,NW,0,6,0,6);
      add(addressesPanel,aConstraints,cancelNewAddressButton=new Button("Cancel"),
        1,4,1,1,0,0,1,1,NO,NW,0,6,0,6);
      newNicknameField.setForeground(Color.black);
      newFullnameField.setForeground(Color.black);
      newAddressField.setForeground(Color.black);
      saveAddressButton.setForeground(Color.black);
      cancelNewAddressButton.setForeground(Color.black);
      addressesPanel.paintAll(addressesPanel.getGraphics());      
    }

    /*  On click of "save" button for a new address
     */
    else if (e.target==saveAddressButton)
    {
      String newNickname = newNicknameField.getText().trim();
      if (newNickname.length()==0)
      {
        statusBar(spaces+"You must enter a nickname"+spaces);
        ignoreLostFocus = true;
        newNicknameField.requestFocus();
        return true;
      }
      else if (newNickname.length()>9)
      {
        statusBar(spaces+"Nicknames must be nine characters or less"+spaces);
        ignoreLostFocus = true;
        newNicknameField.requestFocus();
        return true;
      }
      else if (newFullnameField.getText().indexOf('\\')!=-1)
      {
        statusBar(spaces+"Cannot use \\ in name"+spaces);
        ignoreLostFocus = true;
        newFullnameField.requestFocus();
        return true;
      }
      else if (newAddressField.getText().trim().length()==0)
      {
        statusBar(spaces+"You must enter an email address"+spaces);
        ignoreLostFocus = true;
        newAddressField.requestFocus();
        return true;
      }
      else if (validEmailAddress(newAddressField.getText().trim()))
      {
        for (int a=0;a<c.numberOfAddresses();a++)
	{
          if (c.nickname(a).equals(newNickname)) 
	  {
            statusBar(spaces+"That nickname already exists!"+spaces);
            ignoreLostFocus = true;
            newNicknameField.requestFocus();
            return true;
          }
        }

        clearCommands();
        add(commands,commandsConstraints,
          new Label("Adding address                                           "
                   +"                                                         "),0,0);
        commands.paintAll(commands.getGraphics());

        try 
        { 
          c.use();
          boolean successful = c.addAddress(newNicknameField.getText().trim(),
            newFullnameField.getText().trim(),newAddressField.getText().trim());
          if (successful)
	  {
            listAddresses(currentAddressPage,true);             
            lockButtons(false);
          }
          else newAddressField.requestFocus();
          c.done(); 
        } catch (IOException e7) 
        {
          error();
          lockButtons(false);
        }
        clearCommands();
        add(commands,commandsConstraints,newAddressButton,0,0);
        add(commands,commandsConstraints,showFingerprintButton,1,0);
        commands.paintAll(commands.getGraphics());
      }
      else
      {
        newAddressField.requestFocus();
        statusBar(spaces+"Bad email address"+spaces);
      }
    }

    /*  On click of "Cancel" button for a new address
     */
    else if (e.target==cancelNewAddressButton)
    {
      listAddressesNoReload(currentAddressPage);
      lockButtons(false);
    }

    /* Buttons for changing pages
     */
    else if (e.target==nextMessagePageButton) 
    {
      listMessagesNoReload(c.folderName(),currentMessagePage+1);
      commands.remove(deleteButton);
      commands.remove(saveButton);
      showSelectFunctionButtons(messagesSelected()>0,1);      
    }
    else if (e.target==previousMessagePageButton) 
    {
      listMessagesNoReload(c.folderName(),currentMessagePage-1);
      commands.remove(deleteButton);
      commands.remove(saveButton);
      showSelectFunctionButtons(messagesSelected()>0,1);
    }
    else if (e.target==nextFolderPageButton) 
    {
      listFoldersNoReload(currentFolderPage+1);
      commands.remove(deleteButton);
      commands.remove(renameButton);
      showSelectFunctionButtons(foldersSelected()>0,2);
    }  
    else if (e.target==previousFolderPageButton) 
    {
      listFoldersNoReload(currentFolderPage-1);
      commands.remove(deleteButton);
      commands.remove(renameButton);
      showSelectFunctionButtons(foldersSelected()>0,2);
    }
    else if (e.target==nextAddressPageButton) listAddressesNoReload(currentAddressPage+1);
    else if (e.target==previousAddressPageButton) listAddressesNoReload(currentAddressPage-1);

    /*  If the encrypt checkbox has been clicked
     */
    else if (e.target==encryptCheckbox)
    {
      /* Check to make sure we're only encrypting to hushmail addresses.
       */
      if (encryptCheckbox.getState())
      {
        for (int n=0;n<3;n++)
        {
          String t = headerField[n].getText().trim();
          int l = t.length();
          if (l>0)
	  {
            if (!toHushmail(t))
	    {
              encryptCheckbox.setState(false);
              statusBar(spaces+"Can only encrypt to addresses @"+c.domain()+spaces);
              break;
            }
	  }
        }
      }
      else statusBar(spaces+"Warning: this message will not be sent securely"+spaces);
    }

    else if (e.target==actualMessageCheckbox)
    {
       try 
       {
         readMessage(c.messageID(),false);
       } catch (IOException cantHappen) {}
    }
 
    /* Check the address choices on the "Compose" screen
     */
   
    else if (currentScreen.equals(COMPOSE_SCREEN))
    {
      /* Iterate through fields on compose screen checking for address book grabbing
       */
      for (int n=0;n<3;n++)
      {
        if (e.target==addressChoice[n])
        {
          if (addressChoice[n].getSelectedIndex()!=0)
  	  {
            String address;
            if (c.fullname(addressChoice[n].getSelectedIndex()-1).length()>0) 
              address="\""+c.fullname(addressChoice[n].getSelectedIndex()-1)+"\" <"+c.addresses(addressChoice[n].getSelectedIndex()-1)+">";
            else address=c.addresses(addressChoice[n].getSelectedIndex()-1);
            String fieldText = headerField[n].getText();
            if (!fieldText.equals("")) headerField[n].setText(fieldText+", "+address);
            else headerField[n].setText(address);
            addressChoice[n].select(0);
            if (!toHushmail(address))
            {
             encryptCheckbox.setState(false);
             statusBar(spaces+"Warning: mail sent to this address will not be secure"+spaces);
            }
          }
          composePanel.paintAll(composePanel.getGraphics());
          break;
        }
      }  
    }

    /************************************************************************
     *  The following conditionals involve the arrays of buttons associated
     *  with lists of messages, folders, or addresses
     ************************************************************************/
   

    /* The array of buttons with a list of folders
     */
    else if (currentScreen.equals(LIST_FOLDERS))
    {
      /* Iterate through list of folders currently displayed checking status of buttons on each
       */
      for (int x=currentFolderPage*linesPerPage;x<currentFolderPage*linesPerPage+numberOfFoldersDisplayed;x++)
      { 

	/* On click of "Open" button 
         */
        if (e.target==openFolderButton[x])
        {
          lockButtons(true);
          clearCommands();                 
          add(commands,commandsConstraints,
            new Label("Opening folder                                           "
                     +"                                                         "),0,0);
          commands.paintAll(commands.getGraphics());
          try 
          { 
            c.use();
            listMessages(c.folderName(x),0,true);
            c.done();
          } catch (IOException e8) {error();}
          currentScreen = LIST_MESSAGES_SCREEN;
          mainLayout.show(main,currentScreen);
          clearCommands();
          if (c.numberOfMessages()>0) add(commands,commandsConstraints,selectAllButton,0,0);
          lockButtons(false);
          break;
        }

	/* On click of "Select" button
         */
        else if (e.target==selectFolderButton[x])
        {
          if (folderSelected[x]) 
          {
            unselectFolder(x);
            showSelectFunctionButtons(foldersSelected()>0,2);
          }
          else 
          {
            selectFolder(x);
            showSelectFunctionButtons(true,2);
          }
          break;
        }
      }
    }

    /* The array of buttons with a list of messages
     */
    else if (currentScreen.equals(LIST_MESSAGES_SCREEN))
    {
	/* Iterate through list of messages checking status of buttons on each
         */
      for (int x=currentMessagePage*linesPerPage;
        x<currentMessagePage*linesPerPage+numberOfMessagesDisplayed;x++)
      {  
	/* On click of "Read" button
         */
        if (e.target==readMessageButton[x])
        { 
          lockButtons(true);
          clearCommands();
          add(commands,commandsConstraints,
            new Label("Retrieving message                             "
                     +"                                               "),0,0);
          commands.paintAll(commands.getGraphics());
          try 
          { 
            if (c.folderName().equals(DRAFTS_BOX))
	    {
              c.use();
              getDraft(c.messageID(x));
              c.deleteMessage(c.messageID(x));
              currentScreen = COMPOSE_SCREEN;
              mainLayout.show(main, currentScreen);
              listMessages(c.folderName(),0,true);
              listFolders(0,true);
              c.done();
              clearCommands();
              add(commands,commandsConstraints,backButton,0,0);
              add(commands,commandsConstraints,clearButton,1,0);
              add(commands,commandsConstraints,saveDraftButton,2,0);
              add(commands,commandsConstraints,sendButton,3,0);     
            }
            else
	    {
              c.use();
              readMessage(c.messageID(x),true);
              currentScreen = READ_SCREEN;
              mainLayout.show(main,currentScreen);
              if (!c.read(x))
	      {
                listMessages(c.folderName(),currentMessagePage,true);
                listFolders(currentFolderPage,true);
              }
              c.done();
              clearCommands(); 
              add(commands,commandsConstraints,backButton,0,0);
              add(commands,commandsConstraints,replyButton,1,0);
              add(commands,commandsConstraints,forwardButton,2,0);
              add(commands,commandsConstraints,deleteButtonR,3,0);
              add(commands,commandsConstraints,saveButtonR,4,0);
	    }
          } 
          catch (IOException e9) 
          { 
            clearCommands();
            add(commands,commandsConstraints,selectAllButton,0,0);
            showSelectFunctionButtons(messagesSelected()>0,1);
            e9.printStackTrace();
            error();
          }
          lockButtons(false);    
          break;
        }

	/* On click of "Select" button
         */
        else if (e.target==selectMessageButton[x])
        {
          if (messageSelected[x])
          {
            unselectMessage(x);
            if (messagesSelected()==0)
              showSelectFunctionButtons(false,0);
          }
          else 
          {
            selectMessage(x);
            showSelectFunctionButtons(true,1);
          }
          break;
        }
      }
    }

    /* The array of buttons with a list of addresses
     */
    else if (currentScreen.equals(ADDRESSES))
    {
      /* Iterate through list of addresses checking status of buttons on each
       */
      for (int x=currentAddressPage*linesPerPage;
        x<currentAddressPage*linesPerPage+numberOfAddressesDisplayed;x++)
      {  
	/* On click of "Edit" button
         */
        if (e.target==addressEditButton[x])
        {
	  /*  If the address is not yet in edit mode
	   */
          if (addressEditButton[x].getLabel().equals("Edit"))
          {
            addressEditButton[x].setLabel("Save");
            lockButtons(true);
            add(addressesPanel,aConstraints,editNickname = 
              new TextField(c.nickname(x),9),2,x+1,1,1,0,0,0,0,NO,NW,0,6,0,6);
            editNickname.setForeground(Color.black);
            add(addressesPanel,aConstraints,editFullname = 
              new TextField(c.fullname(x),smallApplet?13:19),3,x+1);
            editFullname.setForeground(Color.black);
            add(addressesPanel,aConstraints,editAddresses = 
              new TextField(c.addresses(x),smallApplet?13:19),4,x+1);
            editAddresses.setForeground(Color.black);
            addressesPanel.remove(nickname[x]);
            addressesPanel.remove(fullname[x]);
            addressesPanel.remove(addresses[x]);
            for (int y=0;y<c.numberOfAddresses();y++) //fix bug By Zhou Wu on May 20.
	    //for (int y=currentPage*linesPerPage; y<c.numberOfAddresses()&&y<currentPage*linesPerPage+linesPerPage; y++)
            {
		if (addressDeleteButton[y] == null) // not in current page: comment By Zhou Wu on May 20.
		{
		    continue;
		}
		    //System.err.println("Error is here");
		    
		addressDeleteButton[y].disable();
             
		if (addressEditButton[y].getLabel().equals("Edit"))
		{
		    addressEditButton[y].disable(); 
		}
            }
            addressesPanel.paintAll(addressesPanel.getGraphics());
            editNickname.requestFocus();
            if (c.fingerprints(x).length()>0)
	    {
              if (smallApplet) 
                statusBar(spaces+"Pub key fingerprint: "+c.fingerprints(x)+spaces); 
              else statusBar(spaces+"Public key fingerprint: "+c.fingerprints(x)+spaces);
            }
            break;
          }
  
          /*  If the address is already in edit mode.
           */
          else if (addressEditButton[x].getLabel().equals("Save"))
          {
            String newNickname = editNickname.getText().trim();
            if (newNickname.equals(c.nickname(x)) && editFullname.getText().equals(c.fullname(x)) 
              && editAddresses.getText().equals(c.addresses(x)))
	    {
              clearCommands();
              add(commands,commandsConstraints,newAddressButton,0,0);
              add(commands,commandsConstraints,showFingerprintButton,1,0);
              commands.paintAll(commands.getGraphics());
              try
	      {
                listAddresses(currentAddressPage,false);
              } catch (IOException e1) { /* Can't happen */ }
              lockButtons(false);
              return true;
            }
            else if (newNickname.length()==0)
            {
              statusBar(spaces+"You must enter a nickname"+spaces);
              ignoreLostFocus = true;
              editNickname.requestFocus();
              return true;
            }
            else if (newNickname.length()>9)
            {
              statusBar(spaces+"Nicknames must be nine characters or less"+spaces);
              ignoreLostFocus = true;
              editNickname.requestFocus();
              return true;
            }
            else if (editFullname.getText().indexOf('\\')!=-1)
	    {
              statusBar(spaces+"Cannot use \\ in name"+spaces);
              ignoreLostFocus = true;
              editFullname.requestFocus();
              return true;
            }
            else if (validEmailAddress(editAddresses.getText().trim()))
	    {
              /*  Check to be sure nickname isn't a duplicate
               */
              for (int a=0;a<c.numberOfAddresses();a++)
	      {   
                if (c.nickname(a).equals(newNickname) && a!=x)
	        {
                  statusBar(spaces+"That nickname already exists!"+spaces);
                  ignoreLostFocus = true;
                  editNickname.requestFocus();
                  return true;
                }
              }      

              addressEditButton[x].disable();
              clearCommands();                 
              add(commands,commandsConstraints,
                new Label("Writing changes                                "
                         +"                                               "),0,0);
              commands.paintAll(commands.getGraphics());

              /*  Delete the old address and add the new one.
               */
              try
              { 
                c.use();
                c.deleteAddress(c.nickname(x));
                boolean successful = c.addAddress(newNickname,
                  editFullname.getText().trim(),editAddresses.getText().trim());
                if (successful)
	        {
                  listAddresses(currentAddressPage,true);
                  lockButtons(false);
                }
                else 
                {
                  addressEditButton[x].enable();
                  editAddresses.requestFocus();
                }
                c.done(); 
              } catch (IOException e10) 
              {
                try
		{ 
                  listAddresses(currentAddressPage,false);
                } catch (IOException none) { /* can't happen */ }
                lockButtons(false);
                error();
              }
              clearCommands();                 
              add(commands,commandsConstraints,newAddressButton,0,0);
              add(commands,commandsConstraints,showFingerprintButton,1,0);
            }
            else
	    {
              editAddresses.requestFocus();
              statusBar(spaces+"Bad email address"+spaces);
            }
          }
        }

	/* On click of "Delete" button
         */
        else if (e.target==addressDeleteButton[x])
        {
          markForDelete = x;
          clearCommands();
          lockButtons(true);
          confirmLabel.setText("Are you sure you want to delete this address?");
          add(commands,commandsConstraints,confirmLabel,0,0);
          add(commands,commandsConstraints,confirmDeleteButton,1,0); 
          add(commands,commandsConstraints,cancelDeleteButton,2,0);  
          commands.paintAll(commands.getGraphics()); 
          break;
        }
      }
    }    
    commands.paintAll(commands.getGraphics());
    return true;
  }

    //By Zhou Wu: this varible is used for those typing text first and email addresses after
    //private boolean specialSend;

    public boolean gotFocus(Event e, Object o)
	{
	    if (!currentScreen.equals(COMPOSE_SCREEN)) return true;
	    
	    if (e.target == cBody)
	    {
		for ( int i=0; i<3; i++) {
		    String text = headerField[i].getText();
		    if( text.trim().length()<=0) continue;
		    if (!toHushmail(text))
		    {
			encryptCheckbox.setState(false);
			statusBar(spaces+"Warning: mail sent to this address will not be secure"+spaces);
		    }
				
		}
	    return false;
	    }
	    return true;
	}	    
  public boolean lostFocus(Event e, Object o)
  {
     /* Exit if still on login screen
      */
     if (currentScreen.equals(LOGIN_SCREEN)) return true;

     /* This takes care of substituting actual addresses for nicknames 
      * on the compose screen, and checks for bad email addresses
      */
     else if (e.target==headerField[0]||e.target==headerField[1]||e.target==headerField[2])
     {
       TextField text = (TextField)e.target;
       text.setText(text.getText().trim());
       if (text.getText().length()>0)
       {
         for (int x=0; x<c.numberOfAddresses(); x++)
         {
           if (text.getText().equalsIgnoreCase(c.nickname(x)))
           {
             if (c.fullname(x).length()>0) text.setText("\""+c.fullname(x).trim()+"\" <"+c.addresses(x).trim()+">");
             else text.setText(c.addresses(x).trim());
             break;
             //return true;
           }
         }
         boolean allLettersAndDigits = true; 
         char[] addrChr = new char[text.getText().length()];
         addrChr = text.getText().toCharArray();
         for (int c=0;c<text.getText().length();c++)    
	 {
           if (!Character.isLetterOrDigit(addrChr[c]) && addrChr[c]!='_' && addrChr[c]!='-' && addrChr[c]!='.')
	   {
             allLettersAndDigits = false;
             break;

           }
         }
         if (allLettersAndDigits)
	 {
           text.setText(text.getText()+"@"+c.domain());
           return true;
         }
         if (!validEmailAddresses(text.getText())) 
         {
           ignoreLostFocus = true;
           text.requestFocus();
           return true;
         }
         else 
         {
           ignoreLostFocus = false;
         }
	 /*       if (!toHushmail(text.getText()))
         {
           encryptCheckbox.setState(false);
           statusBar(spaces+"Warning: mail sent to this address will not be secure"+spaces);
	   } */
       }
       else 
       {
         if (ignoreLostFocus) ignoreLostFocus = false;
       }
     }
     else 
     {
       if (ignoreLostFocus) ignoreLostFocus = false;
     }
     return false; 
  }

  /* Enqueue one bit off each keystroke
   */

  long keyTime0 = 0;
  long keyTime1 = 0;
  long keyTime2 = 0;
  int lastKey = 0;

  public boolean keyUp (Event e, int key)
  {
    /* Update rotateCount for ad changes
     */
    rotateCount++;     

    long now = new Date().getTime();
    if (keyTime0 == 0)
    {
      keyTime0 = now; 
      lastKey = key;
      return true;
    }
    if (keyTime1 == 0) 
    {
      keyTime1 = now;
      lastKey = key;
      return true;
    }    
    if (keyTime2!=0) 
    {
      keyTime0=keyTime1;
      keyTime1=keyTime2;
    }
    keyTime2 = now;
    long diff0 = keyTime1 - keyTime0;
    long diff1 = keyTime2 - keyTime1;
    if (diff0==diff1) return true;
    c.enqueueBit( (long) ( (  diff0 + lastKey > diff1 + key ) ? 0 : 1 ), 1 );
    lastKey = key;
    return true;
  }
  
 
/***********************************************************************************
 *  The "commands" panel
 *  This panel is on the top of the applet
 *  It consists of a set of buttons which perform actions specific
 *  To whichever screen is currently displayed in the "main" panel
 ***********************************************************************************/

  /*  Layout objects for "commands" panel
   */
  private Panel commands = new Panel();
  private GridBagLayout commandsLayout = new GridBagLayout();
  private GridBagConstraints commandsConstraints = new GridBagConstraints();
  private Label newNameLabel = new Label("Enter new folder name:");
  private Label saveMessageLabel = new Label("Choose a folder:");
  private Label confirmLabel = new Label("Are you sure?");
  private Choice folderChoice;
  private TextField renameFolderField, newFolderField;

    /*  The buttons used on the "commands" panel
     */
    private Button selectAllButton, deleteButton, sendButton, backButton, 
    newFolderButton, replyButton, clearButton, forwardButton, saveButton, 
    renameButton, newAddressButton, smallNewFolderButton, smallSaveButton, 
    smallRenameButton, cancelNewFolderButton, cancelSaveButton, cancelRenameButton, 
    confirmDeleteButton, cancelDeleteButton, showFingerprintButton, 
    saveDraftButton, deleteButtonR, saveButtonR;


  private Button formatCommandButton(Button b)
  { 
    /**
     *  This method formats buttons on the "commands" panel
     */
    b.setBackground(lightgray);
    b.setForeground(Color.black); 
    b.setFont(new Font("Helvetica",Font.PLAIN,12));
    return b;
  }

  private void setUpCommands()
  {
    /**
     *  This method does basic setup for the "commands" panel
     */
    commands.setLayout(commandsLayout);
    commands.setBackground(color); 
    commands.setForeground(Color.black);
    commands.setFont(new Font("Helvetica", Font.BOLD, 12));
    selectAllButton = formatCommandButton(new Button("Select All"));    
    deleteButton = formatCommandButton(new Button("Delete Selected"));   
    deleteButtonR = formatCommandButton(new Button("Delete"));
    sendButton = new Button("SEND");
    sendButton.setBackground(lightgray);   
    sendButton.setForeground(Color.red);
    sendButton.setFont(new Font("Helvetica",Font.BOLD,12));
    backButton = formatCommandButton(new Button("Back"));
    newFolderButton = formatCommandButton(new Button("New Folder"));
    replyButton = formatCommandButton(new Button("Reply"));
    clearButton = formatCommandButton(new Button("Clear"));
    saveDraftButton = formatCommandButton(new Button("Save draft"));
    showFingerprintButton = formatCommandButton(new Button("Show my fingerprint"));
    forwardButton = formatCommandButton(new Button("Forward"));
    saveButton = formatCommandButton(new Button("Save Selected"));
    saveButtonR = formatCommandButton(new Button("Save"));
    renameButton = formatCommandButton(new Button("Rename Selected"));
    newAddressButton = formatCommandButton(new Button("New Address"));
    smallNewFolderButton = formatCommandButton(new Button("Create Folder"));
    smallSaveButton = formatCommandButton(new Button("Save"));
    smallRenameButton = formatCommandButton(new Button("Rename"));
    cancelNewFolderButton = formatCommandButton(new Button("Cancel"));
    cancelSaveButton = formatCommandButton(new Button("Cancel"));
    cancelRenameButton = formatCommandButton(new Button("Cancel"));
    confirmDeleteButton = formatCommandButton(new Button("Ok"));
    cancelDeleteButton = formatCommandButton(new Button("Cancel"));
    add(commands,commandsConstraints,new Label(""),6,0,1,1,0,0,1,0,NO,W,3,6,3,0);
  }
 
  private void clearCommands()
  {
    /**
     *  This method clears the "commands" panel
     */
    commands.removeAll();
    add(commands,commandsConstraints,new Label(""),6,0,1,1,0,0,1,0,NO,W,3,6,3,0);
    commandsConstraints.weightx = 0;
  }

  private void showSelectFunctionButtons(boolean showIt,int x)
  {
    /**
     *  This method displays command buttons on the "commands"
     *  panel based on which screen is currently displayed
     *  and which folders or messages are currently selected
     *  x indicates the horizontal position where the row
     *  of select function buttons should start.
     */
    if (showIt)
    {

      /*  If either messages or folders are selected we need a "Delete Selected" button
       */
      add(commands,commandsConstraints,deleteButton,x,0);

      /*  If messages are selected on the "messages" screen, we need "Save Selected" button
       */
      if (currentScreen.equals(LIST_MESSAGES_SCREEN)) add(commands,commandsConstraints,saveButton,x+1,0);
          else commands.remove(saveButton);

      /*  If only one folder is selected we need a "Rename Selected" button
       */
      if (currentScreen.equals(LIST_FOLDERS) && foldersSelected()==1) add(commands,commandsConstraints,renameButton,x+1,0);
          else commands.remove(renameButton);
    }
    else
    {
      commands.remove(deleteButton);
      commands.remove(saveButton);
      commands.remove(renameButton);
    }

    if ((currentScreen.equals(LIST_FOLDERS) &&
	 foldersSelected()==numberOfFoldersDisplayed)||
	(currentScreen.equals(LIST_MESSAGES_SCREEN) &&
	 messagesSelected()==numberOfMessagesDisplayed
         && c.numberOfMessages()>0)
         )
    {
	selectAllButton.setLabel("Deselect all");
	commands.remove(selectAllButton);
      if (currentScreen.equals(LIST_FOLDERS))
	  add(commands,commandsConstraints,selectAllButton,1,0);
      else
	  add(commands,commandsConstraints,selectAllButton,0,0);
    }
    else
    {
        //By Zhou wu on May 20, 1999
        selectAllButton.setLabel("Select all");
	if (c.numberOfMessages()==0 &&
            currentScreen.equals(LIST_MESSAGES_SCREEN))
	    commands.remove(selectAllButton);
    }
  }


  private void lockButtons(boolean lock)
  {
    /**
     *  This method either locks or unlocks all buttons. 
     */
    if (lock)
    {
      lockMenu = true;
      sendButton.disable();
      backButton.disable();
      replyButton.disable();
      forwardButton.disable();
      selectAllButton.disable();
      clearButton.disable();
      saveDraftButton.disable();
      showFingerprintButton.disable();
      deleteButton.disable();
      saveButton.disable();
      deleteButtonR.disable();
      saveButtonR.disable();
      renameButton.disable();
      newFolderButton.disable();
      newAddressButton.disable();
      previousAddressPageButton.disable(); // by Zhou Wu, May 27
      nextAddressPageButton.disable(); // By Zhou Wu, May 27
      previousMessagePageButton.disable();
      nextMessagePageButton.disable(); 
      previousFolderPageButton.disable();
      nextFolderPageButton.disable();
      for (int x=currentFolderPage*linesPerPage;x<currentFolderPage*linesPerPage+numberOfFoldersDisplayed;x++)
      {
        selectFolderButton[x].disable();
        openFolderButton[x].disable();
      }
      for (int x=currentMessagePage*linesPerPage;
        x<currentMessagePage*linesPerPage+numberOfMessagesDisplayed;x++)
      {
        selectMessageButton[x].disable();
        readMessageButton[x].disable();
      }
      for (int x=currentAddressPage*linesPerPage;
        x<currentAddressPage*linesPerPage+numberOfAddressesDisplayed;x++)
      {
        if (addressEditButton[x].getLabel().equals("Edit")) addressEditButton[x].disable();
        addressDeleteButton[x].disable();
      }
      Component[] c = composePanel.getComponents();
      for (int x=0;x<c.length;x++) c[x].disable();
      c = readPanel.getComponents();
      for (int x=0;x<c.length;x++) c[x].disable();
    }
    else
    {
      lockMenu = false;
      sendButton.enable();
      backButton.enable();
      replyButton.enable();
      forwardButton.enable();
      selectAllButton.enable();
      clearButton.enable();
      saveDraftButton.enable();
      showFingerprintButton.enable();
      deleteButton.enable();
      saveButton.enable();
      deleteButtonR.enable();
      saveButtonR.enable();
      renameButton.enable();
      newFolderButton.enable();
      newAddressButton.enable();
      previousAddressPageButton.enable(); // by Zhou Wu, May 27
      nextAddressPageButton.enable(); // By Zhou Wu, May 27
         previousMessagePageButton.enable();
      nextMessagePageButton.enable();
      previousFolderPageButton.enable();
      nextFolderPageButton.enable();
      for (int x=currentFolderPage*linesPerPage;
        x<currentFolderPage*linesPerPage+numberOfFoldersDisplayed;x++)
      {
        selectFolderButton[x].enable();
        openFolderButton[x].enable();
      }
      for (int x=currentMessagePage*linesPerPage;
        x<currentMessagePage*linesPerPage+numberOfMessagesDisplayed;x++)
      {
        selectMessageButton[x].enable();
        readMessageButton[x].enable();
      }
      for (int x=currentAddressPage*linesPerPage;
        x<currentAddressPage*linesPerPage+numberOfAddressesDisplayed;x++)
      {
        addressEditButton[x].enable();
        addressDeleteButton[x].enable();
      }
      Component[] c = composePanel.getComponents();
      for (int x=0;x<c.length;x++) c[x].enable();
      c = readPanel.getComponents();
      for (int x=0;x<c.length;x++) c[x].enable();
    } 
  }


/***********************************************************************************
 *  The "main" panel
 *  This panel is the central panel of the applet upon which
 *  most information is displayed.  It consists of five screens, only one
 *  of which can be displayed at a time.  The screens are "listFolders",
 *  "listMessages", "read", "compose", and "addresses".
 ***********************************************************************************/

  private Panel main = new Panel();
  private CardLayout mainLayout = new CardLayout();
  private void setUpMain()
  { 
    /**
     *  This method does basic setup for the "main" panel.
     *  It also calls methods which setup each of
     *  the five pages which make up the "main" panel
     */
    main.setBackground(Color.black);
    main.setForeground(Color.white);
    main.setLayout(mainLayout); 
    main.setFont(new Font("Helvetica", Font.BOLD, 18));
    setUpListFoldersPanel();
    setUplistMessagesPanel();
    setUpComposePanel();
    setUpAddressesPanel();
    setUpReadPanel();      
  }


/***********************************************************************************
 *  The "listFolders" screen.  Part of the "main" panel.
 *  This page consists of a list of the users folders and buttons that
 *  allow each folder to be opened or selected.
 ***********************************************************************************/

  private Panel listFoldersPanel = new Panel(); 
  private GridBagLayout lFLayout = new GridBagLayout();
  private GridBagConstraints lFConstraints = new GridBagConstraints();
  private Button[] openFolderButton;
  private Checkbox[] selectFolderButton;
  private boolean[] folderSelected;
  private int currentFolderPage;
  private int numberOfFoldersDisplayed;
  private Button nextFolderPageButton;
  private Button previousFolderPageButton;
  private Label[] folderNames;
  private Label[] messages;
  private Label[] unreadMessages;
 

  private void setUpListFoldersPanel()
  {
    /**
     *  This method does basic setup for the "main" panel.
     *  It also calls methods which setup each of
     *  the five pages which make up the "main" panel
     */
    listFoldersPanel.setLayout(lFLayout);
    listFoldersPanel.setBackground(Color.white);
    listFoldersPanel.setForeground(darkgray);
    listFoldersPanel.setFont(fixed);
    formatButton3(nextFolderPageButton = new Button("Next Page"));
    formatButton3(previousFolderPageButton = new Button("Previous Page"));
    main.add(LIST_FOLDERS,listFoldersPanel);
  }

  private void listFoldersNoReload(int page)
  {
    try
    {
      listFolders(page, false);
    } catch (IOException e) {}
  }

  private void listFolders(int page, boolean reload) throws IOException
  {

    /**
     *  This method redraws the "listFolders" screen.
     *  page - indicates which page of folders to display (starts at 0) 
     *  reload - indicates whether folder list should be retrieved from server
     *  If reloading c.use() should be called first and c.done() after.
     */


    /* Clear previous selection information
     */
    for (int n=0;n<c.numberOfFolders();n++) folderSelected[n]=false;

    /*  Reset "global" variable indicating current page
     */
    currentFolderPage=page;

    /*  If requested, retrieve folders from server
     */
    if (reload) 
    {

      c.getFolders();

    }

    /* Clear the "listFolders" screen
     */
    listFoldersPanel.removeAll();

    add(listFoldersPanel,lFConstraints,new Label("Select"),1,0,1,1,0,0,0,0,NO,C,0,6,0,0);
    add(listFoldersPanel,lFConstraints,new Label("Name"),2,0,1,1,0,0,0,0,NO,C,0,6,0,0);
    add(listFoldersPanel,lFConstraints,new Label("Messages"),3,0);
    add(listFoldersPanel,lFConstraints,new Label("Unread"),4,0,1,1,0,0,0,0,NO,C,0,6,0,0);
    add(listFoldersPanel,lFConstraints,new Label(""),5,0,1,1,0,0,1,0,NO,C,0,6,0,0);

    openFolderButton = new Button[c.numberOfFolders()];
    selectFolderButton = new Checkbox[c.numberOfFolders()];
    folderSelected = new boolean[c.numberOfFolders()];
    folderNames = new Label[c.numberOfFolders()];
    messages = new Label[c.numberOfFolders()];
    unreadMessages = new Label[c.numberOfFolders()];

    /* This variable is used to give vertical weight
     * to the last line displayed
     */
    int wy = 0;

    int x;

    numberOfFoldersDisplayed=0;

    for (x=page*linesPerPage; x<c.numberOfFolders()&&x<page*linesPerPage+linesPerPage; x++)
    {
      formatButton3(openFolderButton[x] = new Button("Open"));
      selectFolderButton[x] = new Checkbox();

      /* Clear previous selection information
       */
      folderSelected[x] = false;

      folderNames[x] = new Label(clipFolderInfo(c.folderName(x)));
      folderNames[x].setForeground(Color.black);
      messages[x] = new Label(String.valueOf(c.numberOfMessages(x)));
      messages[x].setForeground(Color.black);
      unreadMessages[x] = new Label(String.valueOf(c.numberOfUnreadMessages(x)));
      unreadMessages[x].setForeground(Color.black);
      add(listFoldersPanel,lFConstraints,openFolderButton[x],0,x+1,1,1,0,0,0,wy,NO,NW,0,12,0,6);
      add(listFoldersPanel,lFConstraints,selectFolderButton[x],1,x+1,1,1,0,0,0,0,NO,C,0,6,0,6);
      add(listFoldersPanel,lFConstraints,folderNames[x],2,x+1,1,1,0,0,0,wy,NO,NW,0,6,0,0);
      add(listFoldersPanel,lFConstraints,messages[x],3,x+1,1,1,0,0,0,wy,NO,N,0,6,0,0);
      add(listFoldersPanel,lFConstraints,unreadMessages[x],4,x+1,1,1,0,0,0,wy,NO,N,0,6,0,0);      
      numberOfFoldersDisplayed++;
    }

    /* Add page turning buttons
     */
    if (page!=0) 
      add(listFoldersPanel,lFConstraints,previousFolderPageButton,2,x+2,1,1,0,0,0,1,NO,NW,0,6,0,0);
    if (c.numberOfFolders()>(page+1)*linesPerPage) 
      add(listFoldersPanel,lFConstraints,nextFolderPageButton,3,x+2,1,1,0,0,0,1,NO,NW,0,6,0,0);
    else if (page==0) add(listFoldersPanel,lFConstraints,new Label(""),3,x+2,1,1,0,0,0,1,NO,NW,0,6,0,0);
    listFoldersPanel.paintAll(listFoldersPanel.getGraphics());
  }

  private void selectFolder(int x)
  {
    /**
     *  This method is called to select a folder
     */
    folderSelected[x]=true;
    selectFolderButton[x].setState(true);
    folderNames[x].setForeground(Color.white);
    folderNames[x].setBackground(Color.black);
    folderNames[x].setText(folderNames[x].getText()+" ");
    messages[x].setForeground(Color.white);
    messages[x].setBackground(Color.black);
    messages[x].setText(messages[x].getText()+" ");
    unreadMessages[x].setForeground(Color.white);
    unreadMessages[x].setBackground(Color.black);
    unreadMessages[x].setText(unreadMessages[x].getText()+" ");
  }
  
  private void unselectFolder(int x)
  {
    /**
     *  This method is called to unselect a folder
     */
    folderSelected[x]=false;
    selectFolderButton[x].setState(false);
    folderNames[x].setForeground(Color.black);
    folderNames[x].setBackground(Color.white);
    folderNames[x].setText(folderNames[x].getText().substring(0,folderNames[x].getText().length()-1));
    messages[x].setForeground(Color.black);
    messages[x].setBackground(Color.white);
    messages[x].setText(messages[x].getText().substring(0,messages[x].getText().length()-1));
    unreadMessages[x].setForeground(Color.black);
    unreadMessages[x].setBackground(Color.white);
    unreadMessages[x].setText(unreadMessages[x].getText().substring(0,unreadMessages[x].getText().length()-1));
  }

  private int foldersSelected()
  {
    /**
     *  This method returns the number of folders curently selected.
     */
    int count=0;
    for (int x=0;x<c.numberOfFolders();x++) if (folderSelected[x]) count++;
    return count;
  }


/***********************************************************************************
 *  The "listMessages" screen.  Part of the "main" panel.
 *  This page consists of a list of the messages in the currently open
 *  folder and buttons that allow each messages to be opened or selected.
 ***********************************************************************************/
  
  private Panel listMessagesPanel = new Panel(); 
  private GridBagLayout lMLayout = new GridBagLayout();
  private GridBagConstraints lMConstraints = new GridBagConstraints();
  private Button[] readMessageButton;
  private Checkbox[] selectMessageButton;
  private boolean[] messageSelected;
  private int currentMessagePage;
  private int numberOfMessagesDisplayed;
  private Button nextMessagePageButton;
  private Button previousMessagePageButton;
  private Label[] from;
  private Label[] subject;
  private Label[] read;
  private Label[] size;
  private Label[] date;

  private void setUplistMessagesPanel()
  {
    /**
     *  This method performs basic setup for the "listMessages" screen
     */
    listMessagesPanel.setLayout(lMLayout);
    listMessagesPanel.setBackground(Color.white); 
    listMessagesPanel.setForeground(darkgray); 
    listMessagesPanel.setFont(fixed); 
    formatButton3(nextMessagePageButton = new Button("Next Page"));
    formatButton3(previousMessagePageButton = new Button("Previous Page"));
    main.add(LIST_MESSAGES_SCREEN,listMessagesPanel);
  }

  private void listMessagesNoReload(String folderName, int page)
  {
    try
    {
      listMessages(folderName, page, false);
    } catch (IOException e) {}
  }

  private void listMessages(String folderName, int page, boolean reload) throws IOException
  {
    /**
     *  This method redraws the "listMessages" screen.
     *  folderName - indicates which folder messages are contained in
     *  page - indicates which page of messages to display (starts at 0)
     *  reload - indicates whether message list should be retrieved from server
     *  If reloading c.use() should be called first and c.done() after.
     */

    /* Clear previous selection information
     */
    for (int n=0;n<c.numberOfMessages();n++) messageSelected[n]=false;

    /*  Reset "global" variable indicating current page
     */
    currentMessagePage=page;

    /*  If requested, retrieve folders from server
     */
    if (reload) c.openFolder(folderName);

    /* Clear the "listMessages" screen
     */
    listMessagesPanel.removeAll();

    if (c.numberOfMessages()>0)
    {
      add(listMessagesPanel,lMConstraints,new Label("Select"),1,0,1,1,0,0,0,0,NO,C,0,6,0,0);
	Label fromLabel = new Label("From");
      add(listMessagesPanel,lMConstraints,fromLabel,2,0,1,1,0,0,0,0,NO,C,0,6,0,0);
      add(listMessagesPanel,lMConstraints,new Label("Subject"),3,0);
      if (!smallApplet)
      {
        add(listMessagesPanel,lMConstraints,new Label("Date"),4,0);
        add(listMessagesPanel,lMConstraints,new Label("Size"),5,0);
      }
      add(listMessagesPanel,lMConstraints,new Label(""),6,0,1,1,0,0,1,0,NO,C,0,6,0,0);

      readMessageButton = new Button[c.numberOfMessages()];
      selectMessageButton = new Checkbox[c.numberOfMessages()];
      Label[] messageID = new Label[c.numberOfMessages()];  //Probably not needed
      from = new Label[c.numberOfMessages()];
      subject = new Label[c.numberOfMessages()];
      read = new Label[c.numberOfMessages()];
      if (!smallApplet)
      {
        date = new Label[c.numberOfMessages()];
        size = new Label[c.numberOfMessages()];
      }
      messageSelected = new boolean[c.numberOfMessages()];

      /* This variable is used to give vertical weight
       * to the last line displayed
       */
      int wy = 0;

      int x;
      numberOfMessagesDisplayed=0;
      String buttonCaption = "Read";
      if (folderName.equals(DRAFTS_BOX)) buttonCaption="Continue";

      for (x=page*linesPerPage; x<c.numberOfMessages()&&x<page*linesPerPage+linesPerPage; x++)
      {
        formatButton3(readMessageButton[x] = new Button(buttonCaption));
        //formatButton3(selectMessageButton[x] = new Button("Select"));
        selectMessageButton[x] = new Checkbox();

        if (c.from(x).equals(c.emailAddress()))
	{
          fromLabel.setText("From/To");
          from[x] = new Label(clipMessageInfo(c.to(x)));
        }
        else from[x] = new Label(clipMessageInfo(c.from(x)));

        if (c.subject(x).trim().length()==0)
          subject[x] = new Label("no subject");
        else subject[x] = new Label(clipMessageInfo(c.subject(x)));

        if (!smallApplet)
	{
          date[x] = new Label(c.date(x).substring(4,10));
          size[x] = new Label(String.valueOf(c.messageSize(x)));
        }

        /*  List unread messages in highlighted color
         */
        if (!c.read(x))
        {
          from[x].setForeground(red);
          subject[x].setForeground(red);
          if (!smallApplet)
	  {
            date[x].setForeground(red);
            size[x].setForeground(red);
          }
        }
        else
        {
          from[x].setForeground(Color.black);
          subject[x].setForeground(Color.black);
          if (!smallApplet)
	  {
            date[x].setForeground(Color.black);
            size[x].setForeground(Color.black);
          }
        }

        add(listMessagesPanel,lMConstraints,readMessageButton[x],0,x+1,1,1,0,0,0,wy,NO,N,0,12,0,6);
        add(listMessagesPanel,lMConstraints,selectMessageButton[x],1,x+1,1,1,0,0,0,0,NO,C,0,6,0,6);
        add(listMessagesPanel,lMConstraints,from[x],2,x+1,1,1,0,0,0,wy,NO,NW,0,6,0,0);
        add(listMessagesPanel,lMConstraints,subject[x],3,x+1);
        if (!smallApplet)
	{
          add(listMessagesPanel,lMConstraints,date[x],4,x+1);
          add(listMessagesPanel,lMConstraints,size[x],5,x+1);
        }
        numberOfMessagesDisplayed++;
      }

      /* Add page turning buttons
       */
      if (page!=0)
      {
        add(listMessagesPanel,lMConstraints,previousMessagePageButton,2,x+2,1,1,0,0,0,0,NO,NW,0,6,0,0);
      }

      add(listMessagesPanel,lMConstraints, new Label(clipMessageInfo(c.folderName())),2,x+3,1,1,0,0,0,1,NO,SW,0,6,0,6);

      if (c.numberOfMessages()>(page+1)*linesPerPage)
      {
        add(listMessagesPanel,lMConstraints, nextMessagePageButton,3,x+2,1,1,0,0,0,0,NO,NW,0,6,0,6);
        add(listMessagesPanel,lMConstraints,
          new Label(String.valueOf(page*linesPerPage+1)+" to "+String.valueOf(page*linesPerPage
          +linesPerPage)+" of "+c.numberOfMessages()),3,x+3,1,1,0,0,0,1,NO,SE,0,6,0,6);
      }
      else
      {
        add(listMessagesPanel,lMConstraints,
          new Label(String.valueOf(page*linesPerPage+1)+" to "+c.numberOfMessages()
          +" of "+c.numberOfMessages()),3,x+3,1,1,0,0,0,1,NO,SE,0,6,0,6);
      }
    }

    else
    {
      /* Display message if folder is empty
       */
      Label empty = new Label("No messages in " + folderName + ".");
      empty.setForeground(Color.red);
      //Dimension size = commands.getSize();
       commands.removeAll();
      //comands.setSize(size);
      commands.invalidate();
      if(bDebug)
         debug("Crumble ");
      add(listMessagesPanel,lMConstraints,empty,0,0,1,1,0,0,1,1,NO,NW,0,6,0,6);
    }

   listMessagesPanel.paintAll(listMessagesPanel.getGraphics());
  }

  private void selectMessage(int x)
  {
    /**
     *  This method is called to select a message
     */
    messageSelected[x]=true;
    selectMessageButton[x].setState(true);
    subject[x].setForeground(Color.white);
    subject[x].setBackground(Color.black);
    subject[x].setText(subject[x].getText()+" ");
    from[x].setForeground(Color.white);
    from[x].setBackground(Color.black);
    from[x].setText(from[x].getText()+" ");
    if (!smallApplet)
    {
       date[x].setForeground(Color.white);
       date[x].setBackground(Color.black);
       date[x].setText(date[x].getText()+" ");
       size[x].setForeground(Color.white);
       size[x].setBackground(Color.black);
       size[x].setText(size[x].getText()+" ");
    }
  }
  
  private void unselectMessage(int x)
  {
    /**
     *  This method is called to unselect a message
     */

    Color readColor;
    if (!c.read(x)) readColor = red;
    else readColor = Color.black;
    messageSelected[x]=false;
    selectMessageButton[x].setState(false);
    subject[x].setForeground(readColor);
    subject[x].setBackground(Color.white);
    subject[x].setText(subject[x].getText().substring(0,subject[x].getText().length()-1));
    from[x].setForeground(readColor);
    from[x].setBackground(Color.white);
    from[x].setText(from[x].getText().substring(0,from[x].getText().length()-1));
    if (!smallApplet)
    {
      date[x].setForeground(readColor);
      date[x].setBackground(Color.white);
      date[x].setText(date[x].getText().substring(0,date[x].getText().length()-1));
      size[x].setForeground(readColor);
      size[x].setBackground(Color.white);
      size[x].setText(size[x].getText().substring(0,size[x].getText().length()-1));
    }
  }

  private int messagesSelected()
  {
    /**
     *  This method returns the number of messages currently selected.
     */
    int count=0;
    for (int x=0;x<c.numberOfMessages();x++) if (messageSelected[x]) count++;
    return count;
  }

     
/***********************************************************************************
 *  The "read" screen.  Part of the "main" panel.
 *  This page consists of a textbox in which a message is displayed.
 ***********************************************************************************/

  private Panel readPanel = new Panel();
  private GridBagConstraints rConstraints = new GridBagConstraints();
  private TextField rDate, rSubject, rFrom, rReplyTo, rTo, rCc; 
  private TextArea rBody; 
  private Checkbox actualMessageCheckbox = new Checkbox();

  private void setUpReadPanel()
  {
    /**
     *  This method performs basic setup for the read screen
     */
    readPanel.setLayout(new GridBagLayout());
    readPanel.setBackground(Color.white);
    readPanel.setForeground(Color.black); 
    readPanel.setFont(new Font("Helvetica", Font.PLAIN, 12));
    //By Zhou Wu June 2, 1999
    //<<
    try {
    rBody = new TextArea("",500,500,TextArea.SCROLLBARS_VERTICAL_ONLY);
    //formatTextComponentBody,false);
    } catch (NoSuchMethodError e)
    {

      rBody = new TextArea("",500,500);
    }
     formatTextComponent(rBody,false);
    //>>
    main.add(READ_SCREEN,readPanel);
  }


  private void readMessage(int messageID, boolean reload) throws IOException
  {
    /**
     *  This method displays a message from the currently open folder.
     */
    readPanel.removeAll();
    if (reload) c.getMessage(messageID);
    rBody.setText("");     
    if (actualMessageCheckbox.getState()) rBody.appendText(c.header()+"\n"+c.actualbody());
    else
    {
      rBody.appendText("Date: "+c.date()+"\n");
      rBody.appendText("Subject: "+c.subject()+"\n");
      rBody.appendText("From: "+c.from()+"\n");
      if (c.replyTo().length()>0) rBody.appendText("Reply-to: "+c.replyTo()+"\n");
      if (c.to().length()>0) rBody.appendText("To: "+c.to()+"\n");
      if (c.cc().length()>0) rBody.appendText("Cc: "+c.cc()+"\n");
      if (c.bcc().length()>0) rBody.appendText("Bcc: "+c.bcc()+"\n");
      rBody.appendText("\n"+c.body());
    }
    add(readPanel,rConstraints,rBody,0,0,2,1,0,0,1,1,H,NW,0,0,0,0);
    add(readPanel,rConstraints,new Label("Show actual message"),0,1,1,1,0,0,0,0,NO,NE,0,6,0,0);
    add(readPanel,rConstraints,actualMessageCheckbox,1,1,1,1,0,0,0,0,NO,NW,0,0,0,0);
    readPanel.paintAll(readPanel.getGraphics());
    try
    {
      rBody.setCaretPosition(0);  
    }
    catch (NoSuchMethodError e) {;}    
  }


/***********************************************************************************
 *  The "compose" screen.  Part of the "main" panel.
 *  This page allows a user to compose a message.
 *  It also provides easy access to the addressbook.
 ***********************************************************************************/

  private Panel composePanel = new Panel();
  private GridBagConstraints cConstraints= new GridBagConstraints();
  private TextField cSubject, cReplyTo;
  private Label cDate; 
  private TextArea cBody; 
  private TextField headerField[];
  private Choice fieldChoice[];
  private Choice addressChoice[];
  private Checkbox encryptCheckbox = new Checkbox();
  private Checkbox ccToSelfCheckbox = new Checkbox("  Save copy on send");

  private void setUpComposePanel()
  {
    /**
     *  This method performs basic setup for the "compose" screen
     */
    composePanel.setLayout(new GridBagLayout());
    composePanel.setBackground(Color.white);
    composePanel.setForeground(Color.black); 
    composePanel.setFont(new Font("Helvetica", Font.PLAIN, 12));
    cSubject = new TextField("",500);
    formatTextComponent(cSubject,true);
    cReplyTo = new TextField("",500);
    formatTextComponent(cReplyTo,true);
    try 
    {  
      cBody = new TextArea("",500,500,TextArea.SCROLLBARS_VERTICAL_ONLY);
    }
    catch (NoSuchMethodError e) {

    cBody = new TextArea("",500,500);
    }
    formatTextComponent(cBody,true);

    /* create field and address choices
     * The allow users to set a field as either to, cc, or bcc
     * and to pull addresses from the address book
     */
    fieldChoice = new Choice[3];
    addressChoice = new Choice[3]; 
    headerField = new TextField[3];
    
    cDate = new Label("Date: "+new Date().toString());
    add(composePanel,cConstraints,new Label("From: "+c.emailAddress()),0,0,2,1,0,0,0,0,NO,W,0,6,0,0);
    if (smallApplet) add(composePanel,cConstraints,new Label(""),2,0,1,1,0,0,0,0,NO,C,0,0,0,0);
    else add(composePanel,cConstraints,cDate,2,0,1,1,0,0,0,0,NO,C,0,0,0,0);
    add(composePanel,cConstraints,new Label(""),3,0,1,1,0,0,0,0,NO,C,0,0,0,6);

    add(composePanel,cConstraints,new Label("Subject:"),0,1,1,1,0,0,0,0,H,W,0,6,0,0);
    add(composePanel,cConstraints,cSubject,1,1,3,1,0,0,0,0,B,E,0,0,0,6);

    for (int n=0;n<3;n++)
    {
      headerField[n]=new TextField();
      formatTextComponent(headerField[n],true);
      fieldChoice[n]=new Choice(); 
      fieldChoice[n].setForeground(Color.black);
      fieldChoice[n].setBackground(Color.white);
      fieldChoice[n].addItem("To:");
      fieldChoice[n].addItem("Cc:");
      fieldChoice[n].addItem("Bcc:");
      addressChoice[n]=new Choice();
      add(composePanel,cConstraints,fieldChoice[n],0,2+n,1,1,0,0,0,0,B,W,0,6,0,0);
      add(composePanel,cConstraints,headerField[n],1,2+n,2,1,0,0,1,0,B,C,0,0,0,0);     
      add(composePanel,cConstraints,addressChoice[n],3,2+n,1,1,0,0,0,0,B,E,0,0,0,6);
     
    }
    
    fieldChoice[1].select("Cc:");
    fieldChoice[2].select("Bcc:");
    encryptCheckbox.setState(true);
    ccToSelfCheckbox.setState(true);
    add(composePanel,cConstraints,encryptCheckbox,0,5,1,1,0,0,0,0,NO,E,0,6,0,0);
    add(composePanel,cConstraints,new Label("Send securely"),1,5,1,1,0,0,0,0,NO,W,0,0,0,0);
    add(composePanel,cConstraints,ccToSelfCheckbox,2,5,1,1,0,0,0,0,NO,E,0,0,0,0);
    add(composePanel,cConstraints,cBody,0,6,R,1,0,0,1,1,NO,C,0,6,0,6);
    main.add(COMPOSE_SCREEN,composePanel);   
  }

  private void getDraft(int messageID) throws IOException
  {
    c.getMessage(messageID);
    compose(
      c.subject().replace('\n',' '),c.replyTo().replace('\n',' '),
      c.to().replace('\n',' '),c.cc().replace('\n',' '),
      c.bcc().replace('\n',' '),c.body());
    c.wipeMessage();
  }

  private void compose(String subject, String replyTo, String to, String cc, String bcc, String body)
  {
    /**
     *  This method sets fields on the compose screen
     *  as is done for replies or forwards
     */
    if ((to.length()>0 && !toHushmail(to))
      || (cc.length()>0 && !toHushmail(cc))
      || (bcc.length()>0 && !toHushmail(bcc)))
    { 
      encryptCheckbox.setState(false);
      statusBar(spaces+"Warning: this message cannot be securely sent to these recipients"+spaces);
    }
    else encryptCheckbox.setState(true);

    cSubject.setText(subject);
    cReplyTo.setText(replyTo);
    cBody.setText(body);
    fieldChoice[0].select("To:");
    headerField[0].setText(to);
    fieldChoice[1].select("Cc:");
    headerField[1].setText(cc);
    fieldChoice[2].select("Bcc:");
    headerField[2].setText(bcc);
    composePanel.paintAll(composePanel.getGraphics());
  }

  private void updateAddressChoices()
  {
    /**
     *  This method updates the address selection choices on the "compose" screen
     *  based on the addresses most recently loaded from the server
     */
    for (int n=0;n<3;n++)
    {
      composePanel.remove(headerField[n]);
      composePanel.remove(addressChoice[n]);
      addressChoice[n]=new Choice();
      addressChoice[n].setForeground(Color.black);
      addressChoice[n].setBackground(Color.white);
      addressChoice[n].addItem(ADDRESSES);
      for (int x=0;x<c.numberOfAddresses();x++) addressChoice[n].addItem(c.nickname(x));
      add(composePanel,cConstraints,headerField[n],1,2+n,2,1,bounds().width-248,0,1,0,B,NW,0,0,0,0);
      add(composePanel,cConstraints,addressChoice[n],3,2+n,R,1,0,0,0,0,B,NE,0,0,0,6);
      addressChoice[n].paintAll(addressChoice[n].getGraphics());
    }
    composePanel.paintAll(composePanel.getGraphics());
  }


/***********************************************************************************
 *  The "addresses" screen.  Part of the "main" panel.
 *  This page allows a to create, edit, or delete addresses
 *  in his addressbook.
 ***********************************************************************************/
  
  private Panel addressesPanel=new Panel();
  private GridBagConstraints aConstraints=new GridBagConstraints();
  private Button[] addressEditButton;
  private Button[] addressDeleteButton;
  private TextField editNickname;
  private TextField editFullname;
  private TextField editAddresses;  
  private Label[] nickname;
  private Label[] fullname;
  private Label[] addresses;  
  private TextField newNicknameField;
  private TextField newFullnameField;
  private TextField newAddressField;
  private Button saveAddressButton;  
  private Button cancelNewAddressButton;
  private int currentAddressPage;
  private int numberOfAddressesDisplayed;
  private Button previousAddressPageButton;
  private Button nextAddressPageButton;
  private int markForDelete; // If delete button is clicked address is saved during confirmation 

  private void setUpAddressesPanel()
  {
    /**
     *  This method performs basic setup for the address panel.
     */
    addressesPanel.setLayout(new GridBagLayout());
    addressesPanel.setBackground(Color.white); 
    addressesPanel.setForeground(darkgray); 
    addressesPanel.setFont(fixed);
    main.add(ADDRESSES,addressesPanel);
    formatButton3(nextAddressPageButton = new Button("Next Page"));
    formatButton3(previousAddressPageButton = new Button("Previous Page"));
  }

  private void listAddressesNoReload(int page)
  {
    try
    {
      listAddresses(page, false);
    } catch (IOException e) {}
  }


  private void listAddresses(int page, boolean reload) throws IOException
  { 
    /**
     *  This method redraws the "addresses" screen.
     *  page - indicates which page of addresses to display (starts at 0) 
     *  reload - indicates whether address list should be retrieved from server
     *  If reloading try should be called first and c.done() after.
     */
        
    /*  Reset "global" variable indicating current page
     */
    currentAddressPage=page;

    /*  If requested, retrieve addresses from server
     */
    if (reload) c.getAddresses();
 
    /* Clear the "addresses" screen
     */
    addressesPanel.removeAll();
    
    if (c.numberOfAddresses()>0)
    {
      add(addressesPanel,aConstraints,new Label("Nickname"),2,0,1,1,0,0,0,0,NO,N,0,6,0,6);
      add(addressesPanel,aConstraints,new Label("Full Name"),3,0);
      add(addressesPanel,aConstraints,new Label(ADDRESSES),4,0,1,1,0,0,1,0,NO,N,0,6,0,6);
      addressEditButton = new Button[c.numberOfAddresses()];
      addressDeleteButton = new Button[c.numberOfAddresses()];
      nickname = new Label[c.numberOfAddresses()];
      fullname = new Label[c.numberOfAddresses()];
      addresses = new Label[c.numberOfAddresses()];

      /* This variable is used to give vertical weight
       * to the last line displayed
       */
      int wy=0;

      int x;

      numberOfAddressesDisplayed=0;

      /*  Loop to display a page worth of addresses
       */
      for (x=page*linesPerPage; x<c.numberOfAddresses()&&x<page*linesPerPage+linesPerPage; x++)
      {
        formatButton3(addressEditButton[x] = new Button("Edit"));
        formatButton3(addressDeleteButton[x] = new Button("Delete"));
        nickname[x] = new Label(clipAddressInfo(c.nickname(x)));
        nickname[x].setForeground(Color.black);
        fullname[x] = new Label(clipAddressInfo(c.fullname(x)));
        fullname[x].setForeground(Color.black);
        addresses[x] = new Label(clipAddressInfo(c.addresses(x)));
        addresses[x].setForeground(Color.black);

        /*  Give vertical weight if on last line
         */
        if (x==c.numberOfAddresses()-1&&c.numberOfAddresses()<=linesPerPage) wy=1;     
        add(addressesPanel,aConstraints,addressDeleteButton[x],0,x+1,1,1,0,0,0,wy,H,NW,0,12,0,0);
        add(addressesPanel,aConstraints,addressEditButton[x],1,x+1,1,1,0,0,0,wy,H,NW,0,6,0,6);
        add(addressesPanel,aConstraints,nickname[x],2,x+1,1,1,0,0,0,wy,NO,NW,0,6,0,6);
        add(addressesPanel,aConstraints,fullname[x],3,x+1);
        add(addressesPanel,aConstraints,addresses[x],4,x+1,1,1,0,0,1,wy,NO,NW,0,6,0,6);
        numberOfAddressesDisplayed++;
      }

      /* Add page turning buttons
       */
      if (page!=0) add(addressesPanel,aConstraints,previousAddressPageButton,2,x+2,1,1,0,0,0,1,NO,NW,0,6,0,6);
      if (c.numberOfAddresses()>(page+1)*linesPerPage) add(addressesPanel,aConstraints,nextAddressPageButton,3,x+2,1,1,0,0,0,1,NO,NW,0,6,0,6);
    }
    else
    {
      /* Display message if addressbook is empty
       */
      Label empty = new Label("No addresses in addressbook.");
      empty.setForeground(Color.red);
      add(addressesPanel,aConstraints,empty,0,0,1,1,0,0,1,1,NO,NW,0,6,0,6);
    }
    addressesPanel.paintAll(addressesPanel.getGraphics());

    updateAddressChoices();
  }


/***********************************************************************************
 *  Methods and variables to simplify the handling of GridBagLayouts
 ***********************************************************************************/
 
  private int C = GridBagConstraints.CENTER;
  private int N = GridBagConstraints.NORTH;
  private int S = GridBagConstraints.SOUTH;
  private int NW = GridBagConstraints.NORTHWEST;
  private int NE = GridBagConstraints.NORTHEAST;
  private int SW = GridBagConstraints.SOUTHWEST;
  private int SE = GridBagConstraints.SOUTHEAST;
  private int W = GridBagConstraints.WEST;
  private int E = GridBagConstraints.EAST;
  private int B = GridBagConstraints.BOTH;
  private int H = GridBagConstraints.HORIZONTAL;
  private int NO = GridBagConstraints.NONE;
  private int R = GridBagConstraints.REMAINDER;


  private void add(Container cc, GridBagConstraints constraints, Component comp, int x, int y) 
  {
    /**
     *  This method adds a component reusing the previous set of values for
     *  constraints except for gridx and gridy.
     */
    constraints.gridx = x;
    constraints.gridy = y;
    LayoutManager ll = cc.getLayout();
    GridBagLayout g = (GridBagLayout)ll;
    g.setConstraints(comp, constraints);
    cc.add(comp);
  } 

  
  private void add(Container cc, GridBagConstraints constraints, Component comp, 
    int x, int y, int w, int h, int ipx, int ipy, double wtx, double wty, int fill, 
    int anchor, int t, int l, int b, int r) 
  {
    /**
     *  This method adds a component, resetting all constraint values to
     *  the passed parameters
     */
    constraints.gridx = x;
    constraints.gridy = y;
    constraints.gridwidth = w;
    constraints.gridheight = h;
    constraints.ipadx = ipx;
    constraints.ipady = ipy;
    constraints.weightx = wtx;
    constraints.weighty = wty;
    constraints.fill = fill;
    constraints.anchor = anchor;
    constraints.insets = new Insets(t,l,b,r);
    LayoutManager ll = cc.getLayout();
    GridBagLayout g = (GridBagLayout)ll;
    g.setConstraints(comp, constraints);
    cc.add(comp);
  } 


  private void formatButton3(Button b)
  { 
    b.setBackground(lightgray);
    b.setForeground(Color.black); 
    b.setFont(new Font("Helvetica",Font.PLAIN,12));
  }  


  private void formatTextComponent(TextComponent t, boolean editable)
  {
    /**
     *  This method allows easy formatting of text components
     */
    t.setEditable(editable);
    t.setFont(new Font("Helvetica", Font.PLAIN, 12));
    t.setBackground(Color.white);
    t.setForeground(Color.black);
  }
  

  private Font fixed = new Font("Helvetica", Font.PLAIN, 12); 
  private FontMetrics fm = getFontMetrics(fixed);
  private int genW = fm.stringWidth("a");


  private String clipMessageInfo(String inString)
  {    
    /**
     *  This method clips Strings on message lists
     */
    if (fm.stringWidth(inString) <= maxMessageInfoLength) return inString;
    int strW = 0;
    while ((strW = fm.stringWidth(inString)) > maxMessageInfoLength) 
    {
      inString=inString.substring(0,inString.length()- (((( strW - maxMessageInfoLength ) / genW ) / 2 ) +1)) ;
    }
    inString = inString.substring(0,inString.length()-2)+"..";
    return inString;
  }


  private String clipFolderInfo(String inString)
  {    
    /**
     *  This method clips Strings on folder lists
     */
    if (fm.stringWidth(inString) <= maxFolderInfoLength) return inString;
    int strW = 0;
    while ((strW = fm.stringWidth(inString)) > maxFolderInfoLength) 
    {
      inString=inString.substring(0,inString.length()- (((( strW - maxFolderInfoLength ) / genW ) / 2 ) +1)) ;
    }
    inString = inString.substring(0,inString.length()-2)+"..";
    return inString;
  }
  

  private String clipAddressInfo(String inString)
  {    
    /**
     *  This method clips Strings on address lists
     */
    if (fm.stringWidth(inString) <= maxAddressInfoLength) return inString;
    int strW = 0;
    while ((strW = fm.stringWidth(inString)) > maxAddressInfoLength) 
    {
      inString=inString.substring(0,inString.length()- (((( strW - maxAddressInfoLength ) / genW ) / 2 ) +1)) ;
    }
    inString = inString.substring(0,inString.length()-2)+"..";
    return inString;
  }


  private boolean validEmailAddresses(String inString)
  {
    if (inString.length()==0) return true;
    int lastComma=-1;
    boolean inQuotes=false;
    for (int x=0;x<inString.length();x++)
    {
      if (inString.regionMatches(x,"\\",0,1))
      {
        statusBar(spaces+"Bad email address"+spaces);
        return false;
      }
      if (inString.regionMatches(x,"\"",0,1)) inQuotes=!inQuotes;
      else if (!inQuotes&&inString.regionMatches(x,",",0,1))
      {
        if (x==lastComma+1||!validEmailAddress(inString.substring(lastComma+1,x))) 
        {
          statusBar(spaces+"Bad email address"+spaces);
          return false;
        }
        lastComma=x;
      }
    }
    if (inQuotes||lastComma==inString.length()-1||!validEmailAddress(inString.substring(lastComma+1)))
    { 
      statusBar(spaces+"Bad email address"+spaces);
      return false;
    }
    else 
    {
      statusBar(spaces+spaces);
      return true;
    }
  }
  

  private boolean validEmailAddress(String inString)
  {
    /**
     *  Returns true if the parameter is a properly formatted email address,
     *  false otherwise
     *  The only characters this allows in email addresses are letters, numbers, and
     *  . _ - @ 
     */

    inString=inString.trim();

    /*  Inidicates whether '@' has been reached
     */
    boolean foundAt=false;

    /*  Indicates whether the actual email address has been reached or
     *  we're still in the "Full Name" text in a situation where the
     *  actual address is enclosed between "<" and ">". 
     */
    boolean inAddress = true;

    /* are we in a quoted section
     */
    boolean inQuotes = false;

    /*  Indicates that a '<' has been found and were still searching
     *  for a '>'
     */
    boolean needsFinalBrace = false;

    /*  Tracks the number of '.'appearing after '@'
     */
    int dotCount=0;

    /*  Check to see if actual email address is enclosed in brackets
     */
    if (inString.indexOf('<')!=-1) inAddress = false;

    char c[] = new char[inString.length()];
    c = inString.toCharArray();

    int x=0;
    for (;x<inString.length();x++)
    { 
      if (inAddress)
      {
        if (c[x]=='@') 
        {
	  /*  Make sure there's only one '@'
           */
          if (!foundAt) 
          {
            foundAt=true;
            
            /*  If address ends immediately after '@' bad address
             */
            if (x+1==inString.length()) return false;

            /*  If the character after '@' is not a letter or digit bad address
             */  
            if (!Character.isLetterOrDigit(c[x+1])) return false;

            if (x-1==-1 || c[x-1]=='<' || c[x-1]==' ') return false;
          }
          else return false;
        }
        else 
        {
	  /*  If character is not acceptable bad address
           */ 
          if (!(Character.isLetterOrDigit(c[x])||c[x]=='-'||c[x]=='_'||c[x]=='.'||(c[x]=='>'
            &&needsFinalBrace))) return false;
        
          /*  Make sure a closing bracket is only used if needed
           */
          if (c[x]=='>') 
          { 
            needsFinalBrace=false;
            if (x!=inString.length()-1) return false;
          }

          /*  Increment dotCount for '.'
           */
          if (c[x]=='.'&&foundAt) dotCount++;
        }
      }

      /*  Allows "full name" part of address to be skipped
       */
      else
      {
        if (!inAddress && c[x]=='"') 
	{ 
          inQuotes = !inQuotes;
        }
        if (c[x]=='<' && !inQuotes)
	{ 
          inAddress = true;
          needsFinalBrace = true;
        }
      }
    }

    /*  Make sure all conditions have been satisfied.
     */
    if (!(Character.isLetter(inString.charAt(inString.length()-1))
      ||inString.charAt(inString.length()-1)=='>')||!foundAt||dotCount==0||needsFinalBrace) 
      return false;

    return true;
  }

  private boolean validFolderName(String inString)
  {
    /**
     *  This method returns true if inString is a valid foldername
     *  It really only checks for the presence of illegal characters.
     */   
    inString=inString.trim();
    if (inString.length()==0) return false;
    if (inString.length()>32)
    {
      statusBar(spaces+"Foldernames must be 32 characters or less"+spaces);
      return false;
    }
    char c[] = new char[inString.length()];
    c = inString.toCharArray();
    int x=0;
    for (;x<inString.length();x++)
    { 
      if (!(Character.isLetterOrDigit(c[x])||c[x]=='_'||c[x]==' '||c[x]=='-')) 
      { 
        statusBar(spaces+"Invalid folder name"+spaces);
        return false;
      }  
    }
    return true;
  }

  private boolean toHushmail(String inString)
  {
    /*  Returns true if all addresses in a comma
     *  seperated list are to HushMail users
     */
    boolean returnVal=true;
    if (inString.length()==0) return true;
    int lastComma=-1;
    boolean inQuotes=false;
    for (int x=0;x<inString.length();x++)
    {
      if (inString.regionMatches(x,"\"",0,1)) inQuotes=!inQuotes;
      else if (!inQuotes&&inString.regionMatches(x,",",0,1))
      {
        if (!toHushmailSingleAddress(inString.substring(lastComma+1,x))) 
        {
          return false;
        }
        lastComma=x;
      }
    }
    if (!toHushmailSingleAddress(inString.substring(lastComma+1)))
    { 
      return false;
    }
    else 
    {
      return true;
    }
  }

  private boolean toHushmailSingleAddress(String t)
  {
    /*  Returns true if an address is to a HushMail user.
     */
    t = t.trim();
    if (t.length()<c.domain().length()+2) return false;
    else return (t.regionMatches(true,t.length()-c.domain().length()-1,
      "@"+c.domain(),0,c.domain().length()+1)
      ||t.regionMatches(true,t.length()-c.domain().length()-2,
      "@"+c.domain()+">",0,c.domain().length()+2));
  }

  /* This variable is set to true when a call to <Component>.requestFocus()
   * is made immedaitely after a call to statusBar().  It prevents the message
   * on the status bar from being immediately wiped. 
   */
  private boolean ignoreLostFocus = false;

  private boolean ignoreAction = false;

  public void statusBar(String message)

  { 
    /**
     *  This method posts a message on the status bar.  
     *  It will be wiped at the next call of action()
     *  or lostFocus() if !ignoreLostFocus.
     */
    
      statusBar.removeAll();
      statusBarLabel = new Label(message);
      statusBar.add(statusBarLabel);
      statusBarLabel.setAlignment(Label.CENTER);
    if (smallApplet)
    {
	statusBarLabel.setFont(new Font("Helvetica",Font.BOLD,12)); 
    }
    else 
    {
	statusBarLabel.setFont(new Font("Helvetica",Font.BOLD,13)); 
    }
    
    Graphics g = statusBar.getGraphics();
    statusBar.paintAll(g);
    if ( g!= null )
    {
	statusBar.update(g);
	g.dispose();
    }
  }

  /**
   *  Methods and variables for management of ads displayed
   *  around the applet.  
   */

  private int rotateCount = 0;
  private int keyStrokesPerAdRotation = 100;
  private int clicksPerAdRotation = 5;

  public boolean rotateAds()
  {
    /**
     *  This method returns true every few keystrokes or button clicks.
     *  It is intended to be called by javascript embedded in the same html 
     *  that contains the applet and used to rotate a set of ads based on 
     *  actions. 
     */
    if (rotateCount > keyStrokesPerAdRotation)
    {
      rotateCount = 0;
      return true;
    }
    else return false;
  }

  private Label colorLabel(Label l)
  {
    l.setForeground(Color.black);
    return l;
  }

  /**
   *  Other variables accesible thoughout the applet.
   */

  /*  If the small applet is chosen
   */
  private boolean smallApplet = false;

  private Label passphraseLabel;
  private Label statusBarLabel=new Label();
  private TextField passphraseField;
  private Button passphraseButton;
  private Panel statusBar;
  private GridBagLayout appletLayout;
  private GridBagConstraints appletConstraints; 
  private String currentScreen="";
  private Connection c;
  private Color lightgray = new Color(192,192,192);
  private Color darkgray = new Color(100,100,100);
  private Color darkred = new Color(110,0,0);
  private Color orange = new Color(204,153,0);
  private Color ltgreen = new Color(204,204,102);
  private Color red = new Color(204,0,0);
  private Color ltpurple = new Color(153,153,204);
  private Color color;
  private Color bgcolor;

  private Class buttonClass = new Button().getClass();

  /* The number of lines displayed in folderlists, messagelists, addresslists
   */
  private int linesPerPage;

  /* The max length for a string in a folderlist, messagelist, addresslist
   */
  private int maxMessageInfoLength;
  private int maxFolderInfoLength;
  private int maxAddressInfoLength;

  /* The URL to the script that handles exits
   */
public  String exitpage;

  String spaces="                                ";
 
  private void error()
  {
    c.done();
    ignoreLostFocus = true; 
    ignoreAction = true;
    statusBar(spaces+"There has been a communications error"+spaces);
    System.out.println("There has been a communications error");
    stopBlinkingText();
  }

  /*  Methods handling thread that runs blinking text
   *  while applet is busy 
   */

  BlinkingText blink;
    
 public void startBlinkingText()
  {
    if (currentScreen.equals(LOGIN_SCREEN)) return;

    /* Instatiate blinking text thread
     */
    blink = new BlinkingText(getGraphics(),84,16,Color.white,bgcolor);

    blink.startBlink();
  }
 
  public void stopBlinkingText()
  {
    if (blink==null) return;
    blink.stopBlink();
  }

  public void stop()
  {
    /**
     *  Overrides Applet.stop
     */
    stopBlinkingText();
  }
  



    private final static String LOGIN_SCREEN = "login";
    private final static String COMPOSE_SCREEN = "compose";
    private final static String LIST_FOLDERS = "listFolders";
    private final static String LIST_MESSAGES_SCREEN = "listMessages";
    private final static String ADDRESSES = "addresses";
    private final static String READ_SCREEN = "read";
    private final static String INBOX = "inbox";
    private final static String SENT_BOX = "sent";
    private final static String DRAFTS_BOX ="drafts";
    private boolean firstTime = true;

  private final static boolean bDebug = false;
  public  static void debug( String s)
	{
	    System.err.println(s);
	}
}



