/*
 *   File:  PagingApplet.java
 *
 *   Version 1.04 v1a
 *   Copyright 1998, 1999 by Hush Communications Corporation, BWI
 *
 *  Created June 3, 1999
 *  $Author Zhou Wu$
 */

/**
Purpose:
This allow users to arrange to be notified at another email address whenever they receive mail in their HushMail account.
*/

package hush.gui;

import java.applet.Applet;

import java.awt.TextField;
import java.awt.Button;
import java.awt.Panel;
import java.awt.Label;
import java.awt.Container;
import java.awt.LayoutManager;
import java.awt.Insets;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.CardLayout;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.Color;
import java.awt.Font;
import java.awt.Canvas;
import java.awt.Graphics;
import java.awt.Choice;
import java.awt.Toolkit;

import java.awt.event.*;
import java.io.IOException;
import java.io.InputStream;

import java.util.Locale;
import java.util.ResourceBundle;
import java.util.MissingResourceException;
import java.util.PropertyResourceBundle;


import hush.net.PagingConnection;

public class PagingApplet  extends Applet 
{
    private Panel m_cFirstScreenPanel;
    private Panel m_cSecondScreenPanel;
    private InformationPanel m_cInformationScreenPanel;
    private SuccededPanel m_cSuccededScreenPanel;
    private Panel displayPanel;
    private CardLayout cardLayout;
         
    private Color foregroundColor;
    private Color backgroundColor;
    private String m_sUserName;
    private String m_sSessionID;
    private String m_sSessionKey;
    private PagingConnection pagingConnection;


    final TextField passphraseTextField = new TextField(50);
    final TextField emailTextField = new TextField(42);
    final Color buttonColor = new Color(192,192,192);

    public void init()
	{
	    defaultLocal();
	    init0();
	}
    public void init0()
	{

	    setLayout(new BorderLayout());
	    cardLayout = new CardLayout();
	    Font font = new Font("Helvetica",Font.PLAIN,12);
	    setFont(font);
	    displayPanel = new Panel();
 	    displayPanel.setLayout(cardLayout);
	    setUpFirstScreen();
	    setUpSecondScreen();
	    setUpInformationScreen();
	    displayPanel.add(m_cFirstScreenPanel, FIRST_SCREEN);
	    displayPanel.add(m_cSecondScreenPanel, SECOND_SCREEN);
	    displayPanel.add(m_cInformationScreenPanel, INFORMATION_SCREEN);
	    displayPanel.add(m_cSuccededScreenPanel, SUCCEDED_SCREEN);
	    getParameters();
	    m_cFirstScreenPanel.setBackground(backgroundColor);
	    m_cSecondScreenPanel.setBackground(backgroundColor);
	    m_cInformationScreenPanel.setBackground(backgroundColor);
	    add(displayPanel, BorderLayout.CENTER);

	    // Deal with real things.

	    initConnection();
	    //Test();
	    validate();
	    setVisible(true);
	    passphraseTextField.requestFocus();
	    
	}

    private void initConnection()
	{
	    pagingConnection = new PagingConnection(m_sUserName, m_sSessionID, m_sSessionKey);
	    String serverAddress =getCodeBase().getHost();
	    if(!serverAddress.trim().equals(""))
		pagingConnection.setServerAddress(serverAddress);
	}
		


     private void Test()
	{
	    //Panel p=new Panel();
	    //String item={FIRST_SCREEN, SECOND_SCREEN, INFORMATION_SCREEN);
	    final Choice choice = new Choice();
	    /* choice.addItem(FIRST_SCREEN);
	    choice.addItem(SECOND_SCREEN);
	    choice.addItem(INFORMATION_SCREEN);
	    choice.addItem(SUCCESS_PROMPT1+"zwu@hotmail.com " + SUCCESS_PROMPT2+ "zwu@hushmail.com");
	    choice.addItem(CANCEL_PROMPT);
            choice.addItem(MISTYPE_PROMPT);
	    choice.addItem(ERROR_PROMPT);*/
	    choice.addItem("English");
	    choice.addItem("Chinese");

	    choice.addItemListener( new ItemListener()
				      {
					  public void itemStateChanged(ItemEvent ae)
					      {
						  int i=choice.getSelectedIndex();
						  if( i ==0)
						      defaultLocal();
						  else 
						      localize(new Locale("zh", "CN"), "/hush/resources/PagingApplet_zh_CN.properties");
					  removeAll();
					  init0();
					  doLayout();
					  validate();
					  repaint();
					  /* int i = choice.getSelectedIndex();

						  
						  String s= choice.getSelectedItem();
						  //System.out.println(s+">>" + displayPanel);
						   if(i<3)
						      cardLayout.show(displayPanel,s);
						  else 
						  {
						      ((InformationPanel)m_cInformationScreenPanel).setText(s);
						      cardLayout.show(displayPanel,INFORMATION_SCREEN);
						      }
    */
        
					  }
				      });
	    add(choice, BorderLayout.NORTH);
	    }
				      
	    

    private void getParameters()
	{ /** Simple method for getting the parameters */

	    /* Get applet color and size
	     */ 
	    foregroundColor = new Color(Integer.parseInt(getParameter("R1")),
			      Integer.parseInt(getParameter("G1")),
			      Integer.parseInt(getParameter("B1")));
	    backgroundColor = new Color(Integer.parseInt(getParameter("R0")),
				Integer.parseInt(getParameter("G0")),
				Integer.parseInt(getParameter("B0")));
	    m_sUserName = getParameter("username");
	    m_sSessionID = getParameter("sessionID");
	    m_sSessionKey = getParameter("sessionKey");
	}    

    private void setUpFirstScreen()
	{
	    m_cFirstScreenPanel = new Panel();
	    m_cFirstScreenPanel.setLayout(new GridBagLayout());
	    
	    Panel centerPanel = new Panel();
	    centerPanel.setLayout( new GridLayout(0,1));
	    //centerPanel.setBackground(Color.cyan);
	

	    Label promptLabel = new Label(PROMPT + "         ");
	    
	    promptLabel.setAlignment(Label.CENTER);
	    centerPanel.add(promptLabel);
	
	    Panel passPanel = new Panel();
	    passPanel.setLayout(new GridBagLayout());
	    //Label passphraseLabel = new Label(" "+PASSPHRASE+":");
	    //passphraseLabel.setFont(font);

	    passphraseTextField.setBackground(Color.white);
	    passphraseTextField.setForeground(Color.black);
	    passphraseTextField.setEchoChar('*');
	    passphraseTextField.requestFocus();
	    final Button submitButton = new Button(SUBMIT_BUTTON);
	    submitButton.setBackground(buttonColor);
	    submitButton.addActionListener(
		new ActionListener()
		{
		    public void actionPerformed(ActionEvent ae)
			{
			    pagingConnection.setPassphrase(passphraseTextField.getText());
			    passphraseTextField.setText("");
			    try 
			    {
				if(pagingConnection.use())
				{
				    cardLayout.show(displayPanel, SECOND_SCREEN);
				    emailTextField.requestFocus();
				    
				} else 
				{
				    m_cInformationScreenPanel.setText(MISTYPE_PROMPT);
				    cardLayout.show(displayPanel, INFORMATION_SCREEN);
				}
			    } catch (IOException e)
			    {
				e.printStackTrace();
				m_cInformationScreenPanel.setText(ERROR_PROMPT);
				cardLayout.show(displayPanel, INFORMATION_SCREEN);
				pagingConnection.quit();
			    } 
			}
		});

	    //Panel submitPanel = new Panel();
	    //submitPanel.add(submitButton);
	    

	    GridBagConstraints gridBagConstraints = new GridBagConstraints();
	    //add(passPanel, gridBagConstraints, passphraseLabel,0,0,1,0,0,0,1.0,0,NO,W,10,0,5,5);
	    add(passPanel, gridBagConstraints, passphraseTextField,0,0,1,0,0,0,0,1,NO,C,10,0,5,5);
	    add(passPanel, gridBagConstraints, submitButton,1,0,1,0,0,0,1.0,1.0,NO,NW,10,5,5,0);
	    

	    centerPanel.add(passPanel);
	    //centerPanel.add(submitPanel);
            add(m_cFirstScreenPanel,gridBagConstraints,centerPanel,0,0,1,1,0,0,1.0,1,NO,C,10,20,20,10);

	}

    private void setUpSecondScreen()
	{
	    m_cSecondScreenPanel = new Panel();
	    m_cSecondScreenPanel.setLayout(new GridBagLayout());
	    
	    Panel centerPanel = new Panel();
	    centerPanel.setLayout( new GridLayout(0,1));
	    //centerPanel.setBackground(Color.cyan);
	
	    //Font font = new Font("Helvetica",Font.PLAIN,12);
	    MultiLineLabel promptLabel = new MultiLineLabel(SECOND_SCREEN_PROMPT1);
	    centerPanel.add(promptLabel);
	    Panel passPanel = new Panel();
	    passPanel.setLayout(new GridBagLayout());

	    emailTextField.setBackground(Color.white);
	    emailTextField.setForeground(Color.black);
    
	    Panel submitPanel = new Panel();	    
	    final Button submitButton = new Button(SUBMIT_BUTTON);
	    submitButton.setBackground(buttonColor);
	    submitButton.addActionListener(
		new ActionListener()
		{
		    public void actionPerformed(ActionEvent ae)
			{
		      
			    try
			    {
				pagingConnection.encryptAndWrite("SETPAGING\n" +
								 emailTextField.getText().trim()+"\n");
				String result = pagingConnection.readAndDecryptWithResult();
				if ( !result.equals("OK") )
				{
				    m_cInformationScreenPanel.setText(ERROR_PROMPT);
				    cardLayout.show(displayPanel, INFORMATION_SCREEN);
				} else
				{
				    //String information = SUCCESS_PROMPT1;
				    String email1= emailTextField.getText().trim();
				    //information += SUCCESS_PROMPT2;
				    String email2 = m_sUserName + EMAIL_ADDRESS;
				    m_cSuccededScreenPanel.setEmails(email1, email2);
				    cardLayout.show(displayPanel, SUCCEDED_SCREEN);
				}
				    
			    } catch(IOException ioe)
			    {
				m_cInformationScreenPanel.setText(ERROR_PROMPT);
				cardLayout.show(displayPanel, INFORMATION_SCREEN);

			    } finally
			    {
				// pagingConnection.quit(); test
			  
    			    }
			}
		});
			    
	    submitPanel.add(submitButton);
	    GridBagConstraints gridBagConstraints = new GridBagConstraints();
	    add(passPanel, gridBagConstraints, emailTextField,0,0,1,0,0,0,1.0,0,NO,W,10,10,5,5);
	    add(passPanel, gridBagConstraints, submitPanel,1,0,1,1,0,0,1.0,0,NO,E,10,0,5,5);
	    centerPanel.add(passPanel);

            Panel cancelPanel = new Panel();
	    Label label = new Label(SECOND_SCREEN_PROMPT2+":");
	    final Button cancelPagingButton = new Button(CANCEL_PAGING_BUTTON);
	    cancelPagingButton.setBackground(buttonColor);
	    cancelPagingButton.addActionListener(
		new ActionListener()
		{
		    public void actionPerformed(ActionEvent ae)
			{
			    try
			    {
				pagingConnection.encryptAndWrite("CANCELPAGING\n" +
								 emailTextField.getText().trim()+"\n");
				String result = pagingConnection.readAndDecryptWithResult();
				if ( !result.equals("OK") )
				{
				    m_cInformationScreenPanel.setText(ERROR_PROMPT);
				    cardLayout.show(displayPanel, INFORMATION_SCREEN);
				} else
				{
				    m_cInformationScreenPanel.setText(CANCEL_PROMPT);
				    cardLayout.show(displayPanel, INFORMATION_SCREEN);
				}
				    
			    } catch(IOException ioe)
			    {
				m_cInformationScreenPanel.setText(ERROR_PROMPT);
				cardLayout.show(displayPanel, INFORMATION_SCREEN);

			    } finally
			    {
				// pagingConnection.quit(); //Test purpose
			    }

			}
		});


	    cancelPanel.setLayout(new GridBagLayout());
	    add(cancelPanel, gridBagConstraints, label,0,0,3,0,0,0,1.0,0,NO,W, 0,10,5,5);
	    add(cancelPanel, gridBagConstraints, cancelPagingButton,1,0,1,0,0,0,1.0,0,NO,E,0,0,5,5);
	    centerPanel.add(cancelPanel);

	    add(m_cSecondScreenPanel,gridBagConstraints,centerPanel,0,0,1,1,0,0,1.0,1,NO,C,10,20,20,10);
	}

    private void setUpInformationScreen()
	{
	    m_cInformationScreenPanel = new InformationPanel("");
	    m_cSuccededScreenPanel = new SuccededPanel("","");
	}
    
   class SuccededPanel extends Panel
   {
        Label label1, label2, eLabel1, eLabel2;

	public SuccededPanel(String email1, String email2)
	    {
		setLayout(new GridBagLayout());
		
		Panel centerPanel= new Panel();
		centerPanel.setLayout( new GridLayout(0,1));
		label1 = new Label(SUCCESS_PROMPT1);
		eLabel1 = new Label(email1);
		label2 = new Label(SUCCESS_PROMPT2);
		eLabel2 = new Label(email2);
		eLabel1.setForeground(Color.red);
		eLabel2.setForeground(Color.red);
		label1.setAlignment(Label.CENTER);
		label2.setAlignment(Label.CENTER);
		eLabel1.setAlignment(Label.CENTER);
		eLabel2.setAlignment(Label.CENTER);

		centerPanel.add(label1);
		centerPanel.add(eLabel1);
		centerPanel.add(label2);
		centerPanel.add(eLabel2);
	        //multiLineLabel = new MultiLineLabel(
		GridBagConstraints gbc = new GridBagConstraints();
		PagingApplet.add(this,gbc,centerPanel,0,0,1,1,0,0,1.0,1,gbc.NONE,gbc.CENTER,10,20,20,10);
	    }

           void setEmails(String email1, String email2)
	   {
	       eLabel1.setText(email1);
	       eLabel2.setText(email2);
	       eLabel1.invalidate();
	       eLabel2.invalidate();
	       validate();
	   }
   }
  



	    



/***********************************************************************************
 *  Methods and variables to simplify the handling of GridBagLayouts
 ***********************************************************************************/
 
    private int C = GridBagConstraints.CENTER;
    private int N = GridBagConstraints.NORTH;
    private int S = GridBagConstraints.SOUTH;
    private int NW = GridBagConstraints.NORTHWEST;
    private int NE = GridBagConstraints.NORTHEAST;
    private int SW = GridBagConstraints.SOUTHWEST;
    private int SE = GridBagConstraints.SOUTHEAST;
    private int W = GridBagConstraints.WEST;
    private int E = GridBagConstraints.EAST;
    private int B = GridBagConstraints.BOTH;
    private int H = GridBagConstraints.HORIZONTAL;
    private int NO = GridBagConstraints.NONE;
    private int R = GridBagConstraints.REMAINDER;


    private void add(Container cc, GridBagConstraints constraints, Component comp, int x, int y) 
	{
	    /**
	     *  This method adds a component reusing the previous set of values for
	     *  constraints except for gridx and gridy.
	     */
	    constraints.gridx = x;
	    constraints.gridy = y;
	    LayoutManager ll = cc.getLayout();
	    GridBagLayout g = (GridBagLayout)ll;
	    g.setConstraints(comp, constraints);
	    cc.add(comp);
	} 

  
    public static void add(Container cc, GridBagConstraints constraints, Component comp, 
			    int x, int y, int w, int h, int ipx, int ipy, double wtx, double wty, int fill, 
			    int anchor, int t, int l, int b, int r) 
	{
	    /**
	     *  This method adds a component, resetting all constraint values to
	     *  the passed parameters
	     */
	    constraints.gridx = x;
	    constraints.gridy = y;
	    constraints.gridwidth = w;
	    constraints.gridheight = h;
	    constraints.ipadx = ipx;
	    constraints.ipady = ipy;
	    constraints.weightx = wtx;
	    constraints.weighty = wty;
	    constraints.fill = fill;
	    constraints.anchor = anchor;
	    constraints.insets = new Insets(t,l,b,r);
	    LayoutManager ll = cc.getLayout();
	    GridBagLayout g = (GridBagLayout)ll;
	    g.setConstraints(comp, constraints);
	    cc.add(comp);
	}


    public void localize(Locale  locale, String bundleName )
	{
	    InputStream in = null;
	    PropertyResourceBundle rb=null;
	    try{
		Toolkit toolkit =
		    Toolkit.getDefaultToolkit();
		in = this.getClass().getResourceAsStream(bundleName);
		
		if (in == null) 
		    System.out.println("No resource found"); 
		  rb = new PropertyResourceBundle(in);
	      }
	    catch(Exception exc)
	    {
		exc.printStackTrace();
		return;
		//System.out.println( exc +" getting resource " +fileName );
	    }
	  
	    try {
		PROMPT  =  rb.getString(R_PROMPT);
		SECOND_SCREEN_PROMPT1 = rb.getString(R_SECOND_SCREEN_PROMPT1);
		SECOND_SCREEN_PROMPT2 = rb.getString(R_SECOND_SCREEN_PROMPT2);
		CANCEL_PAGING_BUTTON = rb.getString(R_CANCEL_PAGING_BUTTON);
		SUCCESS_PROMPT1 = rb.getString(R_SUCCESS_PROMPT1);
		SUCCESS_PROMPT2 = rb.getString(R_SUCCESS_PROMPT2);
		CANCEL_PROMPT = rb.getString(R_CANCEL_PROMPT);
		MISTYPE_PROMPT = rb.getString(R_MISTYPE_PROMPT);
		ERROR_PROMPT = rb.getString(R_ERROR_PROMPT);
		PASSPHRASE = rb.getString(R_PASSPHRASE);
		SUBMIT_BUTTON=rb.getString(R_SUBMIT_BUTTON);
		USERNAME = rb.getString(R_USERNAME);
		
	    } catch(MissingResourceException mre) {
	    mre.printStackTrace();
	    }
	}


    private void defaultLocal()
	{

	    // Constant Strings used by the first 
	   PROMPT = "Please enter your passphrase" ;
   
    // Constant Strings used by the second screen

	   SECOND_SCREEN_PROMPT1 = "Please enter the email address at which you would like to  receive \nnotifications "+"when you receive new mail at your HushMail address.";

	   SECOND_SCREEN_PROMPT2 = "Or click here to cancel notifications";
	   CANCEL_PAGING_BUTTON = "Cancel Paging";


    // Constant Strings used by the third screen
	   SUCCESS_PROMPT1       = "Thank you.  You will now be notified at";
	   SUCCESS_PROMPT2 = "whenever you receive mail at";
	   CANCEL_PROMPT = "Thank you.  Paging has been canceled.";
	   MISTYPE_PROMPT = "I'm sorry, you entered an incorrect username or passphrase.";
	   ERROR_PROMPT =" I'm sorry, there has been an error.  Please try again later.";

    
    // Common ones?
	   USERNAME = "UserName";
	   PASSPHRASE = "Passphrase";
	   SUBMIT_BUTTON = "Go";

	}
 
    private final static String FIRST_SCREEN = "FirstScreen";
    private final static String SECOND_SCREEN = "SecondScreen";
    private final static String INFORMATION_SCREEN  = "InformationScreen";
    private final static String SUCCEDED_SCREEN="SuccededScreen";
    private final static String EMAIL_ADDRESS = "@hushmail.com";

    // Constant Strings used by the first Screen   
    private   String PROMPT;
   
    // Constant Strings used by the second screen

    private   String SECOND_SCREEN_PROMPT1;

    private   String SECOND_SCREEN_PROMPT2;
    private   String CANCEL_PAGING_BUTTON;


    // Constant Strings used by the third screen
    private   String SUCCESS_PROMPT1;
    private   String SUCCESS_PROMPT2;
    private   String CANCEL_PROMPT;
    private   String MISTYPE_PROMPT;
    private   String ERROR_PROMPT ;

    
    // Common ones?
    private   String USERNAME;
    private   String PASSPHRASE;
    private   String SUBMIT_BUTTON;

    // Resources;
    // Constant Strings used by the first Screen   
    private final static String R_PROMPT = "r_prompt" ;
   
    // Constant Strings used by the second screen

    private final static String R_SECOND_SCREEN_PROMPT1 = "r_second_screen_prompt1";
    private final static String R_SECOND_SCREEN_PROMPT2 = "r_second_screen_prompt2";
    private final static String R_CANCEL_PAGING_BUTTON = "r_cancel_paging_button";


    // Constant Strings used by the third screen
    private final static String R_SUCCESS_PROMPT1 ="r_success_prompt1";
    private final static String R_SUCCESS_PROMPT2 = "r_success_prompt2";
    private final static String R_CANCEL_PROMPT = "r_cancel_prompt";
    private final static String R_MISTYPE_PROMPT = "r_mistype_prompt";
    private final static String R_ERROR_PROMPT = "r_error_prompt";
    
    // Common ones?
    private final static String R_USERNAME = "r_username";
    private final static String R_PASSPHRASE = "r_passphrase";
    private final static String R_SUBMIT_BUTTON = "r_submit_button";

}


 

 
      
